/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
</DEPENDENCIES>
*/
function CountDownMap()
{
	this.countdowns = new Array();
}
CountDownMap.instance = new CountDownMap();
CountDownMap.prototype.addCountDown = function(countdown)
{
	this.countdowns[countdown.getId()] = countdown;
}
CountDownMap.prototype.getCountDown = function(sId)
{
	return this.countdowns[sId];
}
function CountDownWidget(sId, duration, notifyInterval)
{
	if (sId)
	{
		this.init(sId, duration, notifyInterval);
	}
}
CountDownWidget.prototype.init = function(sId, duration, notifyInterval)
{
	this.sId = sId;
	this.duration = duration;
	this.notifyInterval = notifyInterval;
	this.notifier = null;
	
	this.startTime = null;
	CountDownMap.instance.addCountDown(this);
}
CountDownWidget.prototype.getId = function()
{
	return this.sId;
}
CountDownWidget.prototype.setBroker = function(broker)
{
	this.broker = broker;
	this.broker.setManager(this);
}
CountDownWidget.prototype.start = function()
{
	this.valueChanged(this.duration);
}
CountDownWidget.prototype.startCountDown = function()
{
	this.startTime = new Date();
	this.actualPosition = this.duration;
	this.notifier = window.setInterval('CountDownMap.instance.getCountDown(\'' + this.sId + '\').notifyValueChanged()', this.notifyInterval);
	this.broker.countDownStarted();
}
CountDownWidget.prototype.stopCountDown = function()
{
	this.stopNotifier();
	this.broker.countDownStopped();
}
CountDownWidget.prototype.reset = function()
{
	
}
CountDownWidget.prototype.liftOff = function()
{
	this.stopNotifier();
	this.startTime = null;
	this.valueChanged(0);
	this.broker.liftOff();
}
CountDownWidget.prototype.valueChanged = function(actualduration)
{
	var hours = Math.floor(actualduration / 3600000);
	if (hours < 10)
		hours = "0" + hours;
	actualduration = actualduration - (hours * 3600000);
	var minutes = Math.floor(actualduration / 60000);
	if (minutes < 10)
		minutes = "0" + minutes;
	actualduration = actualduration - (minutes * 60000);
	var seconds = Math.floor(actualduration / 1000);
	if (seconds < 10)
		seconds = "0" + seconds;
	this.broker.valueChanged(minutes + ":" + seconds);
}
CountDownWidget.prototype.notifyValueChanged = function()
{
	var now = new Date();
	this.actualPosition = this.actualPosition - this.notifyInterval;
	
	if (this.actualPosition < 0)
		this.liftOff();
	else
		this.valueChanged(this.actualPosition);
}
CountDownWidget.prototype.stopNotifier = function()
{
	if (this.notifier != null)
	{
		window.clearInterval(this.notifier);
		this.notifier = null;
	}
}
