/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
    <DEPENDS>Domlet</DEPENDS>
</DEPENDENCIES>
*/
Division.prototype             = new DomletCtr();
Division.prototype.constructor = Division;
Division.superclass            = DomletCtr.prototype;
function Division(domId, name, parent, initialVisible)
{
    ;
    if (domId) 
    {
        this.init(domId, name, parent, initialVisible);
    }
} 
Division.prototype.init = function(domId, name, parent, initialVisible)
{
    Division.superclass.init.call(this, domId, name, parent);
    ;
    this.addDomlet(new Domlet(
        this.domId,     
        this.name,      
        this.parent     
    ));
    this.horizontalCenter = false;
    this.verticalCenter = false;
    this.bActive = true;
    this.initialVisible = initialVisible;
    this.parentDomElement = this.getParentDomElement();
    ;
    this.oWidget = Browser.getElementById(this.domId);
    this.oCoverElem = null;
  this.assignTimerTime = 10;
  this.assignTimer = null;
  var me = this;
  function assignTimerCallback()
  {
    me.assignTimer = null;
    me.oWidget.style.visibility = 'inherit';
  }
  this.assignTimerCallback = assignTimerCallback;
} 
Division.prototype.setHorizontalCenter = function (center)
{
    this.horizontalCenter = (center == undefined) ? true : center;
}
Division.prototype.setVerticalCenter = function (center)
{
    this.verticalCenter = (center == undefined) ? true : center;
}
Division.prototype.start = function ()
{
    if(this.horizontalCenter || this.verticalCenter)
    {
      var parentX = Browser.getPixelComputedStyle(this.parentDomElement, 'width');
      var parentY = Browser.getPixelComputedStyle(this.parentDomElement, 'height');
      ;
      var thisX = this.oWidget.offsetWidth;
      var thisY = this.oWidget.offsetHeight;
      var thisStyleTop = this.oWidget.style['top'];
      var thisStyleBottom = this.oWidget.style['bottom'];
      var thisStyleLeft = this.oWidget.style['left'];
      var thisStyleRight = this.oWidget.style['right'];
      if ((thisStyleLeft == '') && (thisStyleRight == ''))
      {
          if (this.horizontalCenter)
            Browser.changePixelStyle(this.oWidget, 'left', Math.floor((parentX - thisX) / 2));
      }
      if ((thisStyleTop == '') && (thisStyleBottom == ''))
      {
          if (this.verticalCenter)
            Browser.changePixelStyle(this.oWidget, 'top', Math.floor((parentY - thisY) / 2));
      }
    }
    if (this.initialVisible)
        this.assignTimer = window.setTimeout(this.assignTimerCallback, this.assignTimerTime);
}
Division.prototype.setInactive = function()
{
  if(this.bActive)
  {
    this.bActive = false;
    if(this.oWidget.style.visibility != 'hidden')
    {
      this.cover();
    }
  }
}
Division.prototype.cover = function()
{
  if ( !this.oCoverElem )
  {
    this.oCoverElem = Browser.getCoverElement(this.oWidget);
    Browser.changePixelStyle(this.oCoverElem, 'width', this.oWidget.offsetWidth);
    Browser.changePixelStyle(this.oCoverElem, 'height', this.oWidget.offsetHeight);
    this.oCoverElem.style.position = 'absolute';
    this.oCoverElem.style.visibility = 'hidden';
    if (Browser.getId() == 'moz')
    {
        var range = document.createRange();
        range.setStartBefore(this.oWidget);
        range.insertNode(this.oCoverElem);
    }
    else
    {
        this.oWidget.parentNode.appendChild(this.oCoverElem);
    }
    var pAbsPos = new Point(0,0);
    Browser.getAbsPos(this.oWidget, pAbsPos);
    Browser.moveTo(this.oCoverElem, pAbsPos);
    this.oCoverElem.style.visibility = 'inherit';
   }
}
Division.prototype.setActive = function()
{
  if(!this.bActive)
  {
    this.bActive = true;
    if(this.oWidget.style.visibility != 'hidden')
    {
      this.uncover();
    }
  }
}
Division.prototype.uncover = function()
{
  if ( this.oCoverElem )
  {
    Browser.removeNodeFromParent(this.oCoverElem);
    this.oCoverElem = null;
  }
}
Division.prototype.setVisible = function(visible)
{
  Division.superclass.setVisible.call(this, visible);
  if(!this.bActive)
  {
    if(visible)
    {
      this.cover();
    }
    else
    {
      this.uncover();
    }
  }
}
Division.prototype.getSetInactiveAction = function()
{
  return new ObjectMethodAction(this, "setInactive");
}
Division.prototype.getSetActiveAction = function()
{
  return new ObjectMethodAction(this, "setActive");
}
Division.prototype.getParentDomElement = function()
{
    return Browser.getElementById(this.domId).parentNode;
}
Division.prototype.getChangeBorderColorAction = function(borderColor)
{
    return new ObjectMethodAction(this, "changeBorderColor", borderColor);
}
Division.prototype.changeBorderColor = function(borderColor)
{
    ;
    this.domlets[this.name].setStyle("borderColor", borderColor);
}
Division.prototype.getChangeBorderStyleAction = function(borderStyle)
{
    return new ObjectMethodAction(this, "changeBorderStyle", borderStyle);
}
Division.prototype.changeBorderStyle = function(borderStyle)
{
    ;
    this.domlets[this.name].setStyle("borderStyle", borderStyle);
}
Division.prototype.getChangeColorAction = function(color)
{
    return new ObjectMethodAction(this, "changeColor", color);
}
Division.prototype.changeColor = function(color)
{
    ;
    this.domlets[this.name].setStyle("color", color);
}
Division.prototype.getChangeBgColorAction = function(color)
{
    return new ObjectMethodAction(this, "changeBgColor", color);
}
Division.prototype.changeBgColor = function(color)
{
    ;
    this.domlets[this.name].setStyle("backgroundColor", color);
}
Division.prototype.getChangeDisplayStyleAction = function(displayStyle)
{
    return new ObjectMethodAction(this, "changeDisplayStyle", displayStyle);
}
Division.prototype.changeDisplayStyle = function(displayStyle)
{
    ;
    this.domlets[this.name].setStyle("display", displayStyle);
}
Division.prototype.getChangeStyleClassAction = function(styleclass)
{
    return new ObjectMethodAction(this, "changeStyleClass", styleclass);
}
Division.prototype.changeStyleClass= function(styleclass)
{
    this.domlets[this.name].setStyleClass(styleclass);
}
