/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
    <DEPENDS>Domlet</DEPENDS>
</DEPENDENCIES>
*/
SizeableWidget.prototype = new DomletCtr();
SizeableWidget.prototype.constructor = SizeableWidget;
SizeableWidget.superclass = DomletCtr.prototype;
function SizeableWidget( sId, sSizeableDomId, sSizeableBodyDomId, iMinWidth, iMinHeight, iMaxWidth, iMaxHeight )
{
  if( sId )
  {
    this.init(sId, sSizeableDomId, sSizeableBodyDomId, iMinWidth, iMinHeight, iMaxWidth, iMaxHeight);
  }
}
SizeableWidget.prototype.init = function( sId, sSizeableDomId, sSizeableBodyDomId,
                                          iMinWidth, iMinHeight, iMaxWidth, iMaxHeight )
{
  ;
  this.sId = sId;
  if( !sSizeableDomId )
  {
    ;
    return;
  }
  this.sSizeableDomId = sSizeableDomId;
  this.nSizeable = document.getElementById(sSizeableDomId);
  if( this.nSizeable == null )
  {
    ;
    return;
  }
  this.sSizeableBodyDomId = sSizeableBodyDomId;
  this.nSizeableBody = document.getElementById(sSizeableBodyDomId);
  if( this.nSizeableBody == null )
  {
    ;
    return;
  }
  if( iMinWidth )
    this.iMinWidth = iMinWidth;
  else
    this.iMinWidth = 1;
  if( iMaxWidth )
    this.iMaxWidth = iMaxWidth;
  if( iMinHeight )
    this.iMinHeight = iMinHeight;
  else
    this.iMinHeight = 1;
  if( iMaxHeight )
    this.iMaxHeight = iMaxHeight;
  this.aDockedRight = new Array();
  this.aDockedBottom = new Array();
  this.aSizeChangeListener = new Array();
  this.aBodySizeChangeListener = new Array();
}
SizeableWidget.prototype.getId = function()
{
  return this.sId;
}
SizeableWidget.prototype.registerDockedRight = function( sDomId )
{
  var nElement = document.getElementById(sDomId);
  if( nElement == null )
  {
    ;
    return;
  }
  else
  {
    this.aDockedRight.push(nElement);
  }
}
SizeableWidget.prototype.registerDockedBottom = function( sDomId )
{
  var nElement = document.getElementById(sDomId);
  if( nElement == null )
  {
    ;
    return;
  }
  else
  {
    this.aDockedBottom.push(nElement);
  }
}
SizeableWidget.prototype.registerSizeChangeListener = function( oListener )
{
  if( oListener )
  {
    this.aSizeChangeListener.push(oListener);
  }
}
SizeableWidget.prototype.notifySizeChangeListener = function( iDeltaWidth, iDeltaHeight )
{
  for( var i = 0; i < this.aSizeChangeListener.length; i++ )
  {
    this.aSizeChangeListener[i].handleSizeChange();
  }
}
SizeableWidget.prototype.registerBodySizeChangeListener = function( oListener )
{
  if( oListener )
  {
    this.aBodySizeChangeListener.push(oListener);
  }
}
SizeableWidget.prototype.notifyBodySizeChangeListener = function( iDeltaWidth, iDeltaHeight )
{
  for( var i = 0; i < this.aBodySizeChangeListener.length; i++ )
  {
    this.aBodySizeChangeListener[i].handleSizeChange();
  }
}
SizeableWidget.prototype.getWidth = function()
{
  ;
  return this.nSizeable.scrollWidth;
}
SizeableWidget.prototype.getHeight = function()
{
  ;
  return this.nSizeable.scrollHeight;
}
SizeableWidget.prototype.getBodyWidth = function()
{
  ;
  return this.nSizeableBody.scrollWidth;
}
SizeableWidget.prototype.getBodyHeight = function()
{
  ;
  return this.nSizeableBody.scrollHeight;
}
SizeableWidget.prototype.canSatisfyWidthChange = function( iWidth )
{
  //  ;
  if( !isNaN(iWidth) && this.iMinWidth <= iWidth && (this.iMaxWidth ? this.iMaxWidth >= iWidth : true) )
    return true;
  else
    return false;
}
SizeableWidget.prototype.canSatisfyHeightChange = function( iHeight )
{
  //  ;
  if( !isNaN(iHeight) && this.iMinHeight <= iHeight && (this.iMaxHeight ? this.iMaxHeight >= iHeight : true) )
    return true;
  else
    return false;
}
SizeableWidget.prototype.canSatisfyBodyWidthChange = function( iWidth )
{
  //  ;
  if( !isNaN(iWidth) && iWidth > 1 )
    return true;
  else
    return false;
}
SizeableWidget.prototype.canSatisfyBodyHeightChange = function( iHeight )
{
  //  ;
  if( !isNaN(iHeight) && iHeight > 1 )
    return true;
  else
    return false;
}
SizeableWidget.prototype.setWidth = function( iWidth )
{
  ;
  if( this.canSatisfyWidthChange(iWidth) )
  {
    var delta = iWidth - this.getWidth();
    Browser.changePixelStyle(this.nSizeable, 'width', iWidth);
    this.updateDockedRight(delta);
  }
}
SizeableWidget.prototype.setHeight = function( iHeight )
{
  ;
  if( this.canSatisfyHeightChange(iHeight) )
  {
    var delta = iHeight - this.getHeight();
    ;
    Browser.changePixelStyle(this.nSizeable, 'height', iHeight);
    this.updateDockedBottom(delta);
  }
}
SizeableWidget.prototype.setBodyWidth = function( iWidth )
{
  ;
  if( this.canSatisfyBodyWidthChange(iWidth) )
  {
    Browser.changePixelStyle(this.nSizeableBody, 'width', iWidth);
  }
}
SizeableWidget.prototype.setBodyHeight = function( iHeight )
{
  ;
  if( this.canSatisfyBodyHeightChange(iHeight) )
  {
    Browser.changePixelStyle(this.nSizeableBody, 'height', iHeight);
  }
}
SizeableWidget.prototype.addWidth = function( iDeltaWidth )
{
  ;
  var width = this.getWidth();
  var bodywidth = this.getBodyWidth();
  if( width != -1 && bodywidth != -1
          && this.canSatisfyWidthChange(width + iDeltaWidth)
          && this.canSatisfyBodyWidthChange(bodywidth + iDeltaWidth) )
  {
    this.setWidth(width + iDeltaWidth);
    this.setBodyWidth(bodywidth + iDeltaWidth);
    this.updateDockedRight(iDeltaWidth);
  }
}
SizeableWidget.prototype.addHeight = function( iDeltaHeight )
{
  ;
  var height = this.getHeight();
  var bodyheight = this.getBodyHeight();
  if( height != -1 && bodyheight != -1
          && this.canSatisfyHeightChange(height + iDeltaHeight)
          && this.canSatisfyBodyHeightChange(bodyheight + iDeltaHeight) )
  {
    this.setHeight(height + iDeltaHeight);
    this.setBodyHeight(bodyheight + iDeltaHeight);
    this.updateDockedBottom(iDeltaHeight);
  }
}
SizeableWidget.prototype.updateDockedRight = function( deltaX )
{
  if( !isNaN(deltaX) )
  {
    for( var i = 0; i < this.aDockedRight.length; i++ )
    {
      var currentPos = new Point(0, 0);
      Browser.getLocation(this.aDockedRight[i], currentPos);
      ;
      Browser.moveTo(this.aDockedRight[i], new Point(currentPos.x + deltaX, currentPos.y));
    }
  }
}
SizeableWidget.prototype.updateDockedBottom = function( deltaY )
{
  if( !isNaN(deltaY) )
  {
    for( var i = 0; i < this.aDockedBottom.length; i++ )
    {
      var currentPos = new Point(0, 0);
      Browser.getLocation(this.aDockedBottom[i], currentPos);
      ;
      Browser.moveTo(this.aDockedBottom[i], new Point(currentPos.x, currentPos.y + deltaY));
    }
  }
}
function SizerHandle( sId, sSizerDomId, iStepWidth, iThreshold, bHorizontal, bVertical, bShouldConverge )
{
  if( sId )
  {
    this.init(sId, sSizerDomId, iStepWidth, iThreshold, bHorizontal, bVertical, bShouldConverge);
  }
}
SizerHandle.prototype.init = function( sId, sSizerDomId, iStepWidth, iThreshold,
                                       bHorizontal, bVertical, bShouldConverge )
{
  ;
  this.sId = sId;
  this.sSizerDomId = sSizerDomId;
  this.nSizer = document.getElementById(sSizerDomId);
  if( this.nSizer == null )
  {
    ;
    return;
  }
  this.iStepWidth = iStepWidth;
  this.iThreshold = iThreshold;
  if( bHorizontal != undefined )
    this.isHorizontallyResizable = bHorizontal;
  else
    this.isHorizontallyResizable = true;
  if( bVertical != undefined )
    this.isVerticallyResizable = bVertical;
  else
    this.isVerticallyResizable = true;
  this.shouldConverge = bShouldConverge;
  this.createMouseDownEventHandler();
  this.createMouseUpEventHandler();
  this.createMouseMoveEventHandler();
  Browser.addEventListenerToDomNode(this.nSizer, Browser.eventNames.MOUSEDOWN, this.mouseDownHandler);
  this.alertCount = 0;
}
SizerHandle.prototype.getId = function()
{
  return this.sId;
}
SizerHandle.prototype.setSizeable = function( oSizeable )
{
  this.oSizeable = oSizeable;
}
SizerHandle.prototype.createMouseDownEventHandler = function()
{
  var me = this;
  this.mouseDownHandler = function( event )
  {
    ;
    if( !event )
      event = window.event;
    me.inMouseMove = false;
    me.mouseDownX = event.clientX;
    me.mouseDownY = event.clientY;
    Browser.eventStopPropagation(event);
    Browser.eventPreventDefault(event);
    Browser.addEventListenerToDocument(Browser.eventNames.MOUSEUP, me.mouseUpHandler);
    Browser.addEventListenerToDocument(Browser.eventNames.MOUSEMOVE, me.mouseMoveHandler);
    return false;
  }
}
SizerHandle.prototype.createMouseUpEventHandler = function()
{
  var me = this;
  this.mouseUpHandler = function( event )
  {
    ;
    if( !event )
      event = window.event;
    Browser.removeEventListenerFromDocument(Browser.eventNames.MOUSEMOVE, me.mouseMoveHandler);
    Browser.removeEventListenerFromDocument(Browser.eventNames.MOUSEUP, me.mouseUpHandler);
    me.inMouseMove = false;
    me.stopSizing(event, me.initialWidth, me.initialHeight, me.initialBodyWidth, me.initialBodyHeight);
    me.mouseDownX = null;
    me.mouseDownY = null;
  }
}
SizerHandle.prototype.createMouseMoveEventHandler = function()
{
  var me = this;
  this.mouseMoveHandler = function( event )
  {
    ;
    if( !event )
      event = window.event;
    if( !me.inMouseMove && me.isThresholdExceeded(event) )
    {
      ;
      me.startSizing(event);
      me.inMouseMove = true;
    }
    if( me.inMouseMove )
    {
      ;
      me.changeSize(event, me.initialWidth, me.initialHeight, me.initialBodyWidth, me.initialBodyHeight);
    }
  }
}
SizerHandle.prototype.isThresholdExceeded = function( event )
{
  var isExceeded = false;
  if( !this.iThreshold )
  {
    ;
    return true;
  }
  if( this.isHorizontallyResizable )
    isExceeded = Math.abs(event.clientX - this.mouseDownX) > this.iThreshold;
  if( !isExceeded && this.isVerticallyResizable )
    isExceeded = Math.abs(event.clientY - this.mouseDownY) > this.iThreshold;
  ;
  return isExceeded;
}
SizerHandle.prototype.startSizing = function( event )
{
  ;
  if( this.oSizeable )
  {
    this.initalSizerPos = new Point(0, 0);
    Browser.getLocation(this.nSizer, this.initalSizerPos);
    if( this.isHorizontallyResizable )
    {
      this.initialWidth = this.oSizeable.getWidth();
      this.initialBodyWidth = this.oSizeable.getBodyWidth();
    }
    if( this.isVerticallyResizable )
    {
      this.initialHeight = this.oSizeable.getHeight();
      this.initialBodyHeight = this.oSizeable.getBodyHeight();
    }
    ;
  }
}
SizerHandle.prototype.changeSize = function( event, initialWidth, initialHeight, initialBodyWidth, initialBodyHeight )
{
  ;
  if( this.oSizeable )
  {
    if( this.isHorizontallyResizable && initialWidth && initialBodyWidth )
    {
      var delta = event.clientX - this.mouseDownX;
      if( ! this.shouldConverge )
        this.changeWidth(initialWidth + delta, initialBodyWidth + delta, delta);
      else
        this.changeWidthConverging(initialWidth + delta, initialBodyWidth + delta, delta);
    }
    if( this.isVerticallyResizable && initialHeight && initialBodyHeight )
    {
      var delta = event.clientY - this.mouseDownY;
      if( ! this.shouldConverge )
        this.changeHeight(initialHeight + delta, initialBodyHeight + delta, delta);
      else
        this.changeHeightConverging(initialHeight + delta, initialBodyHeight + delta, delta);
    }
  }
}
SizerHandle.prototype.stopSizing = function( event, initialWidth, initialHeight, initialBodyWidth, initialBodyHeight )
{
  ;
  if( this.oSizeable )
  {
    if( this.isHorizontallyResizable )
    {
      if( this.iStepWidth && this.iStepWidth > 0 )
      {
        var delta = this.calculateNearestDelta(initialWidth, this.oSizeable.getWidth());
        if( !this.shouldConverge )
          this.changeWidth(initialWidth + delta, initialBodyWidth + delta, delta);
        else
          this.changeWidthConverging(initialWidth + delta, initialBodyWidth + delta, delta);
        this.oSizeable.notifySizeChangeListener(delta, 0);
        this.oSizeable.notifyBodySizeChangeListener(delta, 0);
      }
      else
      {
        this.oSizeable.notifySizeChangeListener();
        this.oSizeable.notifyBodySizeChangeListener();
      }
    }
    if( this.isVerticallyResizable )
    {
      if( this.iStepWidth && this.iStepWidth > 0 )
      {
        var delta = this.calculateNearestDelta(initialHeight, this.oSizeable.getHeight());
        if( !this.shouldConverge )
          this.changeHeight(initialHeight + delta, initialBodyHeight + delta, delta);
        else
          this.changeHeightConverging(initialHeight + delta, initialBodyHeight + delta, delta);
        this.oSizeable.notifySizeChangeListener(0, delta);
        this.oSizeable.notifyBodySizeChangeListener(0, delta);
      }
      else
      {
        this.oSizeable.notifySizeChangeListener();
        this.oSizeable.notifyBodySizeChangeListener();
      }
    }
  }
}
SizerHandle.prototype.updatePosition = function( deltaX, deltaY )
{
  if( !isNaN(deltaX) && !isNaN(deltaY) )
  {
    ;
    Browser.moveTo(this.nSizer, new Point(this.initalSizerPos.x + deltaX, this.initalSizerPos.y + deltaY));
  }
}
SizerHandle.prototype.updateLeftPosition = function( deltaX )
{
  if( !isNaN(deltaX) )
  {
    var currentPos = new Point(0, 0);
    Browser.getLocation(this.nSizer, currentPos);
    ;
    Browser.moveTo(this.nSizer, new Point(this.initalSizerPos.x + deltaX, currentPos.y));
  }
}
SizerHandle.prototype.updateTopPosition = function( deltaY )
{
  if( !isNaN(deltaY) )
  {
    var currentPos = new Point(0, 0);
    Browser.getLocation(this.nSizer, currentPos);
    ;
    Browser.moveTo(this.nSizer, new Point(currentPos.x, this.initalSizerPos.y + deltaY));
  }
}
SizerHandle.prototype.hasPassedOverStep = function( iDelta )
{
  return (Math.abs(iDelta) % this.iStepWidth) > this.iStepWidth / 2;
}
SizerHandle.prototype.calculateStepSize = function( iDelta )
{
  if( iDelta < 0 )
    return this.iStepWidth * Math.floor(iDelta / this.iStepWidth);
  else
    return this.iStepWidth * Math.ceil(iDelta / this.iStepWidth);
}
SizerHandle.prototype.calculateNearest = function( iSize )
{
  var low = Math.floor(iSize / this.iStepWidth) * this.iStepWidth;
  var high = Math.ceil(iSize / this.iStepWidth) * this.iStepWidth;
  if( iSize - low < high - iSize )
    return low;
  else
    return high;
}
SizerHandle.prototype.calculateNearestDelta = function( iInitialSize, iCurrentSize )
{
  return this.calculateNearest(iCurrentSize - iInitialSize);
}
SizerHandle.prototype.changeWidth = function( width, bodyWidth, delta )
{
  ;
  if( this.oSizeable.canSatisfyWidthChange(width) && this.oSizeable.canSatisfyBodyWidthChange(bodyWidth) )
  {
    this.oSizeable.setWidth(width);
    this.oSizeable.setBodyWidth(bodyWidth);
    this.updateLeftPosition(delta);
  }
}
SizerHandle.prototype.changeHeight = function( height, bodyHeight, delta )
{
  ;
  if( this.oSizeable.canSatisfyHeightChange(height) && this.oSizeable.canSatisfyBodyHeightChange(bodyHeight) )
  {
    this.oSizeable.setHeight(height);
    ;
    this.oSizeable.setBodyHeight(bodyHeight);
    ;
    this.updateTopPosition(delta);
    ;
  }
}
SizerHandle.prototype.changeWidthConverging = function( width, bodyWidth, delta )
{
  ;
  if( delta > 0 )
  {
    while( !(this.oSizeable.canSatisfyWidthChange(width) && this.oSizeable.canSatisfyBodyWidthChange(bodyWidth)) )
    {
      width--;
      bodyWidth--;
      delta--;
      if( delta == 0 )
        break;
    }
  }
  else if( delta < 0 )
  {
    while( !(this.oSizeable.canSatisfyWidthChange(width) && this.oSizeable.canSatisfyBodyWidthChange(bodyWidth)) )
    {
      width++;
      bodyWidth++;
      delta++;
      if( delta == 0 )
        break;
    }
  }
  if( delta != 0 )
  {
    this.oSizeable.setWidth(width);
    this.oSizeable.setBodyWidth(bodyWidth);
    this.updateLeftPosition(delta);
  }
}
SizerHandle.prototype.changeHeightConverging = function( height, bodyHeight, delta )
{
  ;
  if( delta > 0 )
  {
    while( !( this.oSizeable.canSatisfyHeightChange(height) && this.oSizeable.canSatisfyBodyHeightChange(bodyHeight) ) )
    {
      height--;
      bodyHeight--;
      delta--;
      if( delta == 0 )
        break;
    }
  }
  else if( delta < 0 )
  {
    while( !( this.oSizeable.canSatisfyHeightChange(height) && this.oSizeable.canSatisfyBodyHeightChange(bodyHeight) ) )
    {
      height++;
      bodyHeight++;
      delta++;
      if( delta == 0 )
        break;
    }
  }
  if( delta != 0 )
  {
    this.oSizeable.setHeight(height);
    this.oSizeable.setBodyHeight(bodyHeight);
    this.updateTopPosition(delta);
  }
}
