/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function StopWatch(sId, sStopWatchDomId, sProgressIndicatorDomId)
{
  if (sId) { this.init(sId, sStopWatchDomId, sProgressIndicatorDomId); }
}
StopWatch.prototype.init = function(sId)
{
  ;   
  this.sId = sId;
  this.refreshTime = 1000; 
  this.refreshTimer = null;
  this.aTimeDisplays = new Array();
  this.aMinimumTimeDisplays = new Array();
  this.nTime = 0;
  this.nMinTime = -1;
}
StopWatch.prototype.getId = function()
{
  ;
  return this.sId;
}
StopWatch.prototype.registerTimeDisplay = function(sTimeDisplayDomId)
{
  ;
  function timeDisplayContainer(domNode, sFormatString)
  {
    this.domNode = domNode;
    this.sFormatString = sFormatString;
  }
  var sTimeDisplay = document.getElementById(sTimeDisplayDomId);
  if (sTimeDisplay == null)
  {
    ;
  }
  else
  {
    this.aTimeDisplays.push(new timeDisplayContainer(sTimeDisplay, sTimeDisplay.innerHTML));
    sTimeDisplay.innerHTML = '';
    sTimeDisplay.style.visibility = '';
  }
}
StopWatch.prototype.registerMinimumTimeDisplay = function(sMinimumTimeDisplayDomId)
{
  ;
  function timeDisplayContainer(domNode, sFormatString)
  {
    this.domNode = domNode;
    this.sFormatString = sFormatString;
  }
  var sMinimumTimeDisplay = document.getElementById(sMinimumTimeDisplayDomId);
  if (sMinimumTimeDisplay == null)
  {
    ;
  }
  else
  {
    this.aMinimumTimeDisplays.push(new timeDisplayContainer(sMinimumTimeDisplay, sMinimumTimeDisplay.innerHTML));
    sMinimumTimeDisplay.innerHTML = '';
    sMinimumTimeDisplay.style.visibility = '';
  }
}
StopWatch.prototype.begin = function()
{
  ;
  var me = this;
  refreshTimerCallback = function()
  {
    me.refreshView();
  }
  if ( this.refreshTimer )
  {
    this.end();
  }
  this.refreshTimer = window.setInterval('refreshTimerCallback()', this.refreshTime);
  for ( var i = 0; i < this.aTimeDisplays.length; i++)
  {
    this.addTimeToTimeDisplayContainer(this.aTimeDisplays[i]);
  }
}
StopWatch.prototype.refreshView = function()
{
  ;
  this.nTime += this.refreshTime;
  for ( var i = 0; i < this.aTimeDisplays.length; i++)
  {
    this.addTimeToTimeDisplayContainer(this.aTimeDisplays[i]);
  }
}
StopWatch.prototype.addTimeToTimeDisplayContainer = function(oTimeDisplayContainer)
{
  ;
  var nMinute = Math.floor((this.nTime / 1000) / 60); 
  var nSecound = (this.nTime / 1000)  - ( nMinute * 60);
  if ( nMinute > 99 )
  {
    nMinute = 99;
  }
  nMinute = new String(nMinute);
  if ( nMinute.length == 1 )
  {
    nMinute = '0' + nMinute;
  }
  nSecound = new String(nSecound);
  if ( nSecound.length == 1 )
  {
    nSecound = '0' + nSecound;
  }
  var sFormatString = oTimeDisplayContainer.sFormatString;
  var sOutputString = new String();
  for ( var j = 0; j < sFormatString.length - 1; j++)
  {
    if( sFormatString.charAt(j) == 'm' && sFormatString.charAt(j + 1) == 'm' )
    {
      sOutputString += nMinute;
      continue;
    }
    if( sFormatString.charAt(j) == 's' && sFormatString.charAt(j + 1) == 's' )
    {
      sOutputString += nSecound;
      continue;
    }
    if( j && sFormatString.charAt(j - 1) == 'm' && sFormatString.charAt(j) == 'm' )
    {
      continue;
    }
    if( j && sFormatString.charAt(j - 1) == 's' && sFormatString.charAt(j) == 's' )
    {
      continue;
    }
    sOutputString += sFormatString.charAt(j);
  }
  oTimeDisplayContainer.domNode.innerHTML = sOutputString;
}
StopWatch.prototype.end = function()
{
  ;
  if( this.refreshTimer )
  {
    window.clearInterval( this.refreshTimer );
    this.refreshTimer = null;
  }
  if ( (this.nMinTime == -1) || ( this.nTime < this.nMinTime )) 
  {
    this.nMinTime = this.nTime;
    for ( var i = 0; i < this.aMinimumTimeDisplays.length; i++)
    {
      this.addTimeToTimeDisplayContainer(this.aMinimumTimeDisplays[i]);
    }
  }
  this.nTime = 0;
}
StopWatch.prototype.getMinTime = function()
{
  ;
  return this.nMinTime;
}
StopWatch.prototype.getEndAction = function()
{
    return new ObjectMethodAction(this, "end");
}
StopWatch.prototype.getBeginAction = function()
{
    return new ObjectMethodAction(this, "begin");
}
