/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
    <DEPENDS>Domlet</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
</DEPENDENCIES>
*/
TextPushButton.prototype = new DomletCtr();
TextPushButton.prototype.constructor = TextPushButton;
TextPushButton.superclass = DomletCtr.prototype;
function TextPushButton( domId, enabled, name, parent )
{
  ;
  if( domId ) 
  {
    this.init(domId, enabled, name, parent);
  }
}
TextPushButton.prototype.init = function( domId, enabled, name, parent )
{
  TextPushButton.superclass.init.call(this, domId, name, parent);
  ;
  this.addDomlet(new Domlet(
          this.domId, 
          this.name, 
          this.parent, 
          new Array(
          'mouseover',
          'mouseout',
          'mousedown',
          'mouseup',
          'click'
          )
          ));
  this.state = {
    down : false,          
    highlighted : false   
  };
  this.pressedFgndColor = null;
  this.pressedBgndColor = null;
  this.unpressedFgndColor = null;
  this.unpressedBgndColor = null;
  this.disabledFgndColor = null;
  this.disabledBgndColor = null;
  this.mouseoverFgndColor = null;
  this.mouseoverBgndColor = null;
  this.activeCursor = this.domlets[this.name].getStyle('cursor');
  this.inactiveCursor = this.activeCursor;
  this.state.enabled = ((enabled == undefined) ? true : enabled);
  ;
} 
TextPushButton.prototype.getEnableAction = function()
{
  return new ObjectMethodAction(this, "setEnabled", true);
}
TextPushButton.prototype.getDisableAction = function()
{
  return new ObjectMethodAction(this, "setEnabled", false);
}
TextPushButton.prototype.setPressedAction = function( action )
{
  ;
  this.pressedAction = action;
  ;
}
TextPushButton.prototype.setDownAction = function( action )
{
  ;
  this.downAction = action;
}
TextPushButton.prototype.setUpAction = function( action )
{
  ;
  this.upAction = action;
}
TextPushButton.prototype.setEnabled = function( enabled )
{
  this.state.enabled = enabled;
  if( !enabled )
  {
    this.state.highlighted = false;
    this.state.down = false;
  }
  this.displayState();
}
TextPushButton.prototype.setPressedColor = function( color )
{
  this.pressedFgndColor = color;
}
TextPushButton.prototype.setPressedBgndColor = function( color )
{
  this.pressedBgndColor = color;
}
TextPushButton.prototype.setUnpressedColor = function( color )
{
  this.unpressedFgndColor = color;
}
TextPushButton.prototype.setUnpressedBgndColor = function( color )
{
  this.unpressedBgndColor = color;
}
TextPushButton.prototype.setDisabledColor = function( color )
{
  this.disabledFgndColor = color;
}
TextPushButton.prototype.setDisabledBgndColor = function( color )
{
  this.disabledBgndColor = color;
}
TextPushButton.prototype.setMouseoverColor = function( color )
{
  this.mouseoverFgndColor = color;
}
TextPushButton.prototype.setMouseoverBgndColor = function( color )
{
  this.mouseoverBgndColor = color;
}
TextPushButton.prototype.eventFromChild = function( childName, eventType )
{
  ;
  if( this.state.enabled )
  {
    switch( eventType )
            {
      case "click" :
      {
        if( this.buttonGroupManager )
          this.buttonGroupManager.buttonPushed(this);
        if( this.pressedAction )
        {
          ;
          this.displayState();
          this.pressedAction.invoke();
          break;
        }
      }
      case 'mouseover' :
      {
        this.state.highlighted = true;
        this.displayState();
        break;
      }
      case 'mouseout' :
      {
        this.state.highlighted = false;
        if( this.state.down == true )
        {
          this.state.down = false;
          if( this.upAction )
          {
            ;
            this.upAction.invoke();
          }
        }
        this.displayState();
        break;
      }
      case 'mousedown' :
      {
        this.state.down = true;
        this.displayState();
        if( this.downAction )
        {
          ;
          this.downAction.invoke();
        }
        break;
      }
      case 'mouseup' :
      {
        this.state.down = false;
        this.displayState();
        if( this.upAction )
        {
          ;
          this.upAction.invoke();
        }
        break;
      }
    }
  }
} 
TextPushButton.prototype.displayState = function()
{
  if( this.state.enabled )
  {
    this.domlets[this.name].setStyle('cursor', this.activeCursor);
    if( this.state.highlighted && !this.state.down )
    {
      this.setFgColor(this.mouseoverFgndColor);
      this.setBgColor(this.mouseoverBgndColor);
    }
    else
    {
      if( this.state.down )
      {
        this.setFgColor(this.pressedFgndColor);
        this.setBgColor(this.pressedBgndColor);
      }
      else
      {
        this.setFgColor(this.unpressedFgndColor);
        this.setBgColor(this.unpressedBgndColor);
      }
    }
  }
  else
  {
    this.domlets[this.name].setStyle('cursor', this.inactiveCursor);
    this.setFgColor(this.disabledFgndColor);
    this.setBgColor(this.disabledBgndColor);
  }
}
TextPushButton.prototype.setActiveCursor = function( activeCursor )
{
  this.activeCursor = activeCursor;
}
TextPushButton.prototype.setInactiveCursor = function( inactiveCursor )
{
  this.inactiveCursor = inactiveCursor;
}
TextPushButton.prototype.setFgColor = function( color )
{
  if( color )
    Browser.changeStyleById(this.domId, "color", color);
}
TextPushButton.prototype.setBgColor = function( color )
{
  if( color )
    Browser.changeStyleById(this.domId, "backgroundColor", color);
}
TextPushButton.prototype.start = function()
{
  this.displayState();
}
TextPushButton.prototype.setButtonGroupManager = function( buttonGroupManager )
{
  this.buttonGroupManager = buttonGroupManager;
}
