/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
    <DEPENDS>ScrollArea</DEPENDS>
</DEPENDENCIES>
*/
TextScrollArea.prototype             = new ScrollArea();
TextScrollArea.prototype.constructor = TextScrollArea;
TextScrollArea.superclass            = ScrollArea.prototype;
function TextScrollArea(sId, sWidgetDomId)
{
  if (sId) { this.init(sId, sWidgetDomId); }
}
TextScrollArea.prototype.init = function(sId, sWidgetDomId)
{
  ;
  TextScrollArea.superclass.init.call(this, sId, sWidgetDomId);
  this.sId = sId;
  this.sWidgetDomId = sWidgetDomId;
  this.oWidget = Browser.getElementById(sWidgetDomId);
  if ( ! this.oWidget )
  {
    ;
  }
  this.oWidget.scrollTop = '0px';
  this.oBuffer = null;
  this.minScrollStep = 4;
  this.scrollStep = 10;
  this.defaultScrollInterval = 20;
  this.externalScrollOffset = 0;
  this.scrollDirection = ''; 
  this.bHasScrollBar = false;
  this.sInitString = '';
  this.origWidth = parseInt(Browser.getComputedStyleById(sWidgetDomId,'width'));
  this.origHeight = parseInt(Browser.getComputedStyleById(sWidgetDomId,'height'));
  this.nScrollBarWidth = 20;
  this.sBackgroundColor = this.oWidget.style.backgroundColor;
  if(!this.sBackgroundColor)
  {
    this.sBackgroundColor = '#ffffff';
  }
  this.addDomlet(new Domlet(
    this.sWidgetDomId,     
    this.name,      
    this.parent,    
    new Array('keypress', 'keyup', 'dragdrop')) 
  )
  var me = this;
  this.keyDownHandlerCallback = function()
  {
    me.keyupHandler();
  }
  this.refreshCallback = function()
  {
    me.watchValue();
  }
}
TextScrollArea.prototype.start = function()
{
  ;
  this.oBuffer = this.oWidget.cloneNode(true);
  this.oBuffer.value = this.oWidget.value
  this.oBuffer.id = 'Buffer_' + this.sId;
  this.oBuffer.style.zIndex= parseInt(this.oWidget.parentNode.style.zIndex) + 1;
  this.oBuffer.style.position = 'absolute';
  this.oBuffer.style.top = '0px';
  this.oBuffer.style.left = '0px';
  this.oBuffer.visibility = 'hidden';
  this.oWidget.parentNode.appendChild(this.oBuffer);
  this.oBuffer.style.border = 'none';
  this.oBuffer.style.right = '0px';
  Browser.changePixelStyle(this.oBuffer, 'width', this.origWidth);
  Browser.changePixelStyle(this.oBuffer, 'height', this.origHeight);
  this.oBuffer.visibility = 'visible';
  this.coverInput(true);  
  this.oWidget.value = this.sInitString;
  this.resize();
  this.coverInput(false);  
  this.watchValue();
}
TextScrollArea.prototype.setInitString = function(sInitString)
{
  ;
  this.sInitString=sInitString;
}
TextScrollArea.prototype.scrollTo = function(domId)
{
  ;
}
TextScrollArea.prototype.coverInput = function(bCover)
{
  ;
  if ( bCover )
  {
    this.oBuffer.style.scrollTop = this.oWidget.style.scrollTop;
    this.oBuffer.value = this.oWidget.value;
    this.oBuffer.scrollTop = this.oWidget.scrollTop;
    this.oBuffer.selectionStart = this.oWidget.selectionStart;
    this.oBuffer.selectionEnd = this.oWidget.selectionEnd;
    Browser.changePixelStyle(this.oBuffer, 'width', this.oWidget.style.width);
    this.oBuffer.style.visibility = 'visible';
    var sTemp = this.oWidget.value;
  }
  else
  {
    if (this.oBuffer)
    {
      this.oBuffer.style.visibility = 'hidden';
    }
  }
}
TextScrollArea.prototype.watchValue = function()
{
  //;
  this.resize();
  window.setTimeout(this.refreshCallback, 500);
}
TextScrollArea.prototype.eventFromChild = function(childName, eventType, event)
{
  //;
  var domlet = this.domlets[childName];
  switch(eventType)
  {
    case "keyup" :
      ;
      this.keyupHandler(domlet, event);
      break;
    case "dragdrop" :
      ;
      this.keypressHandler(domlet, event);
      break;
    case "keypress" :
      ;
      this.keypressHandler(domlet, event);
      break;
  }
}
TextScrollArea.prototype.keypressHandler = function(domlet, event)
{
  ;
  this.coverInput(true);
  window.setTimeout(this.keyDownHandlerCallback, 1);
}
TextScrollArea.prototype.keyupHandler = function()
{
  ;
  this.resize();
  this.oWidget.focus();
  this.coverInput(false);
  var width = parseInt(this.oWidget.style.width);
  this.oWidget.style.width = width + 1 + 'px';
  this.oWidget.style.width = width + 'px';
}
TextScrollArea.prototype.resize = function()
{
  ;
  if(this.oWidget.scrollHeight > this.oWidget.clientHeight)
  {
    if ( ! this.bHasScrollBar )
    {
      Browser.changePixelStyle(this.oWidget, 'width', this.origWidth + this.nScrollBarWidth);
      this.bHasScrollBar = true;
    }
  }
  else
  {
    if ( this.bHasScrollBar )
    {
      Browser.changePixelStyle(this.oWidget, 'width', this.origWidth);
      this.bHasScrollBar = false;
    }
  }
}
TextScrollArea.prototype.reset = function()
{
  this.oWidget.value = this.sInitString;
}
TextScrollArea.prototype.getResetAction = function()
{
  return new ObjectMethodAction(this, 'reset');
}
