/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
    <DEPENDS>Domlet</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
</DEPENDENCIES>
*/
TrueFalse.prototype             = new DomletCtr();
TrueFalse.prototype.constructor = TrueFalse;
TrueFalse.superclass            = DomletCtr.prototype;
function TrueFalse(domIdTrue, domIdFalse, imgTrue, imgFalse, imgTrueActive, imgFalseActive, imgTrueTip, imgFalseTip, imgTrueDisabled, imgFalseDisabled, enabled, name, parent)
{
    ;
    if (domIdTrue && domIdFalse) 
    {
        this.init(domIdTrue, domIdFalse, imgTrue, imgFalse, imgTrueActive, imgFalseActive, imgTrueTip, imgFalseTip, imgTrueDisabled, imgFalseDisabled, enabled, name, parent);
    }
} 
TrueFalse.prototype.init = function(domIdTrue, domIdFalse, imgTrue, imgFalse, imgTrueActive, imgFalseActive, imgTrueTip, imgFalseTip, imgTrueDisabled, imgFalseDisabled, enabled, name, parent)
{
    TrueFalse.superclass.init.call(this, domIdTrue, name, parent);
    ;
    this.state = {
        pressed : false,       
        tip     : false,       
        images : {
            imgTrue          : imgTrue,
            imgFalse         : imgFalse,
            imgTrueActive    : imgTrueActive,
            imgFalseActive   : imgFalseActive,
            imgTrueTip       : imgTrueTip,
            imgFalseTip      : imgFalseTip,
            imgTrueDisabled  : imgTrueDisabled,
            imgFalseDisabled : imgFalseDisabled
        }
    };
    this.state.enabled = ((enabled) ? enabled : true); 
    ;
    this.addDomlet(new Domlet(
        domIdTrue, 
        domIdTrue, 
        this,    
        new Array(      
            'click'
        )
    ));
    ;
    this.addDomlet(new Domlet(
        domIdFalse,
        domIdFalse,
        this,    
        new Array(      
            'click'
        )
    ));
    this.domIdTrue = domIdTrue;
    this.domIdFalse = domIdFalse;
    ;
} 
TrueFalse.prototype.setTrueAction = function(action)
{
    ;
    this.trueAction = action;
}
TrueFalse.prototype.setFalseAction = function(action)
{
    ;
    this.falseAction = action;
}
TrueFalse.prototype.getTrueAction = function()
{
    return new ObjectMethodAction(this, "setStatus", "true");
}
TrueFalse.prototype.getFalseAction = function()
{
    return new ObjectMethodAction(this, "setStatus", "false");
}
TrueFalse.prototype.getTipTrueAction = function()
{
    return new ObjectMethodAction(this, "setStatus", "tipTrue");
}
TrueFalse.prototype.getTipFalseAction = function()
{
    return new ObjectMethodAction(this, "setStatus", "tipFalse");
}
TrueFalse.prototype.getDisableAction = function()
{
    return new ObjectMethodAction(this, "setStatus", "disable");
}
TrueFalse.prototype.getEnableAction = function()
{
    return new ObjectMethodAction(this, "setStatus", "enable");
}
TrueFalse.prototype.setStatus = function(status)
{
    ;
    switch (status)
    {
        case "true":
            this.state.pressed = true;
            this.state.tip = false;
            break;
        case "false":
            this.state.pressed = false;
            this.state.tip = false;
            break;
        case "tipTrue":
            this.state.pressed = true;
            this.state.tip = true;
            break;
        case "tipFalse":
            this.state.pressed = false;
            this.state.tip = true;
            break;
        case "disable":
            this.state.enabled = false;
            break;
        case "enable":
            this.state.enabled = true;
            break;
    }
    this.displayState(this.name);
}
TrueFalse.prototype.eventFromChild = function(childName, eventType)
{
    ;
    this.state.eventProcessed = false;
    switch(eventType)
    {
        case "click" :
            if (this.state.enabled)
            {
                if (childName == this.domIdTrue)
                    this.state.pressed = true;
                if (childName == this.domIdFalse)
                    this.state.pressed = false;
                ;
                this.displayState(childName);
                if (this.state.pressed)
                {
                    if (this.trueAction)
                    {
                        ;
                        this.trueAction.invoke();
                    }
                }
                else
                {
                    if (this.falseAction)
                    {
                        ;
                        this.falseAction.invoke();
                    }
                }
                ;
            }
        break;
    }
} 
TrueFalse.prototype.displayState = function(domletName)
{
    var imgSrcTrue;
    var imgSrcFalse;
    if (this.state.pressed)
    {
        if (this.state.tip)
        {
            imgSrcTrue = this.state.images.imgTrueTip;
            imgSrcFalse = this.state.images.imgFalse;
        }
        else
        {
            imgSrcTrue = this.state.images.imgTrueActive;
            imgSrcFalse = this.state.images.imgFalse;
        }
    }
    else
    {
        if (this.state.tip)
        {
            imgSrcTrue = this.state.images.imgTrue;
            imgSrcFalse = this.state.images.imgFalseTip;
        }
        else
        {
            imgSrcTrue = this.state.images.imgTrue;
            imgSrcFalse = this.state.images.imgFalseActive;
        }
    }
    if (!this.state.enabled) 
    {
        imgSrcTrue = this.state.images.imgTrueDisabled;
        imgSrcFalse = this.state.images.imgFalseDisabled;
    }
    if (imgSrcTrue) 
    {
        ;
        this.domlets[this.domIdTrue].setImageSource(imgSrcTrue);
    }
    if (imgSrcFalse) 
    {
        ;
        this.domlets[this.domIdFalse].setImageSource(imgSrcFalse);
    }
} 
