/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Globals</DEPENDS>
    <DEPENDS>Broker</DEPENDS>
</DEPENDENCIES>
*/
ConfirmDialogBroker.prototype             = new Broker();
ConfirmDialogBroker.prototype.constructor = ConfirmDialogBroker;
ConfirmDialogBroker.superclass            = Broker.prototype;
function ConfirmDialogBroker(sId)
{
  if (!sId) sId = "ConfirmDialogBroker";
  this.init(sId);
}
ConfirmDialogBroker.prototype.init = function(sId)
{
  ;
  this.sId = sId;
  this.externalBroker = undefined;
  ConfirmDialogBroker.superclass.init.call(this, sId);
}
ConfirmDialogBroker.prototype.setExternalBroker = function(externalConfirmDialogBroker)
{
	this.externalBroker = externalConfirmDialogBroker;
}
ConfirmDialogBroker.prototype.removeExternalBroker = function()
{
	this.externalBroker = undefined;
}
ConfirmDialogBroker.prototype.doYes = function()
{
  this.getMessage('yes');
}
ConfirmDialogBroker.prototype.addYesHandle = function(action)
{
  this.registerAction('yes', action);
}
ConfirmDialogBroker.prototype.getYesAction = function()
{
  return new ObjectMethodAction(this, 'yes');
}
ConfirmDialogBroker.prototype.yes = function()
{
  ;
    this.beforeYesNo();
  if(this.externalBroker)
  {
  	;
  	this.externalBroker.yes();
  }
  this.doYes();
}
ConfirmDialogBroker.prototype.doNo = function()
{
  this.getMessage('no');
}
ConfirmDialogBroker.prototype.addNoHandle = function(action)
{
  this.registerAction('no', action);
}
ConfirmDialogBroker.prototype.getNoAction = function()
{
  return new ObjectMethodAction(this, 'no');
}
ConfirmDialogBroker.prototype.no = function()
{
  ;
    this.beforeYesNo();
  if(this.externalBroker)
  {
  	;
  	this.externalBroker.no();
  }
  this.doNo();
}
ConfirmDialogBroker.prototype.doAbort = function()
{
  this.getMessage('abort');
}
ConfirmDialogBroker.prototype.addAbortHandle = function(action)
{
  this.registerAction('abort', action);
}
ConfirmDialogBroker.prototype.getAbortAction = function()
{
  return new ObjectMethodAction(this, 'abort');
}
ConfirmDialogBroker.prototype.abort = function()
{
  ;
  if(this.externalBroker)
  {
  	;
  	this.externalBroker.abort();
  }
  this.doAbort();
}
ConfirmDialogBroker.prototype.beforeYesNo = function()
{
  this.getMessage('beforeYesNo');
}
ConfirmDialogBroker.prototype.addBeforeYesNoHandle = function(action)
{
  this.registerAction('beforeYesNo', action);
}
