/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>HandleMap</DEPENDS>
    <DEPENDS>MovieHandle</DEPENDS>
    <DEPENDS>MoviePlayer</DEPENDS>
</DEPENDENCIES>
*/
function MoviePlayerRegistryManager(id, corePlayerHandle)
{
	;
	this.corePlayerHandle = corePlayerHandle;
	this.playerArray = new Array();
	this.playerHandleCount = 0;
	this.broker = new MoviePlayerRegistryManagerBroker();
	this.movieHandles = new Array();
	HandleMap.instance.registerHandle(id, this);
}
MoviePlayerRegistryManager.prototype.register = function(player, handleName)
{
	;
	var moviehandle;
	var alreadyRegistered;
	if (handleName)
	{
		alreadyRegistered = true;
		moviehandle = handleName;
		;
	}
	else
	{
		alreadyRegistered = false;
		moviehandle = 'js_movieplayer_handle_' + this.playerHandleCount++;
		;
	}
	if (player)
	{
		;
		this.movieHandles[player.movieurl] = moviehandle;
	}
	if (this.playerArray[moviehandle])
	{
		;
	}
	else
	{
		this.playerArray[moviehandle] = player;
		
		try
		{
			if (this.corePlayerHandle != undefined)
			{
				
				HandleMap.instance.sendMessage(this.corePlayerHandle, 'movieRegisterAbsolute', [moviehandle, 500, player.movieurl]);
				return new MovieHandle(player, player.movieurl, this.corePlayerHandle, moviehandle);
			}
			else
			{
				
				return new MovieHandle(player, player.movieurl, undefined, moviehandle);
			}
		}
		catch (e)
		{
			;
		}
	}
	
	return new MovieHandle(player, player.movieurl, undefined, moviehandle);
}
MoviePlayerRegistryManager.prototype.getPlayer = function(handle)
{
	return this.playerArray[handle];
}
MoviePlayerRegistryManager.prototype.getHandle = function(movieURl)
{
	return this.movieHandles[movieURl];
}
MoviePlayerRegistryManager.prototype.registerMovie = function(url, moviebroker)
{
	;
	moviePlayer = new MoviePlayer(this, url);
	;
	moviePlayer.setMovieBroker(movieBroker);
	
	return moviePlayer;
}
MoviePlayerRegistryManager.prototype.broadcastSpeedFactor = function(speedFactor)
{
	eval('document.' + this.corePlayerHandle + '.speedfactorbroadcast(speedFactor)');
	HandleMap.instance.sendMessage(this.corePlayerHandle, 'speedfactorbroadcast', [speedFactor]);
}
MoviePlayerRegistryManager.prototype.play = function(handle)
{
	;
	moviePlayer = this.playerArray[handle];
    if (moviePlayer)
        moviePlayer.play();
}
MoviePlayerRegistryManager.prototype.stop = function(handle)
{
	moviePlayer = this.playerArray[handle];
	if (moviePlayer)
        moviePlayer.stop();
}
MoviePlayerRegistryManager.prototype.pause = function(handle)
{
	moviePlayer = this.playerArray[handle];
    if (moviePlayer)
        moviePlayer.pause();
}
MoviePlayerRegistryManager.prototype.rewind = function(handle, amount)
{
	moviePlayer = this.playerArray[handle];
    if (moviePlayer)
        moviePlayer.rewind(amount);
}
MoviePlayerRegistryManager.prototype.forward = function(handle, amount)
{
	moviePlayer = this.playerArray[handle];
    if (moviePlayer)
        moviePlayer.forward(amount);
}
MoviePlayerRegistryManager.prototype.setTimePositionAbsolute = function(handle, time)
{
	;
	moviePlayer = this.playerArray[handle];
	;
	if (moviePlayer)
		moviePlayer.movieBroker.doAbsoluteIntervalReached(time);
}
MoviePlayerRegistryManager.prototype.notifyStart = function(handle)
{
	this.broker.activated();
	;
	moviePlayer = this.playerArray[handle];
	;
	if (moviePlayer)
		moviePlayer.movieBroker.doMovieStarted();
	
}
MoviePlayerRegistryManager.prototype.notifyStop = function(handle)
{
	;
	moviePlayer = this.playerArray[handle];
	;
    if (moviePlayer)
        moviePlayer.movieBroker.doMovieStopped();
	
}
MoviePlayerRegistryManager.prototype.notifyPause = function(handle)
{
	;
	moviePlayer = this.playerArray[handle];
	;
    if (moviePlayer)
        moviePlayer.movieBroker.doMoviePaused();
}
MoviePlayerRegistryManager.prototype.getResetAllAction = function()
{
	return new ObjectMethodAction(this, 'resetAll');
}
MoviePlayerRegistryManager.prototype.resetAll = function()
{
	;
	HandleMap.instance.sendMessage(this.corePlayerHandle, 'reset', []);
}
MoviePlayerRegistryManager.prototype.setMoviePlayerSpeed = function(speedfactor)
{
	;
	HandleMap.instance.sendMessage(this.corePlayerHandle, 'speedfactorbroadcast', [speedfactor]);
}
MoviePlayerRegistryManager.prototype.getSpeedAction = function()
{
	return new ObjectMethodAction(this, 'setMoviePlayerSpeed');
}
MoviePlayerRegistryManager.prototype.addActivatedHandle = function(action)
{
	this.broker.addActivatedHandle( action);
}
MoviePlayerRegistryManagerBroker.prototype = new Broker();
MoviePlayerRegistryManagerBroker.prototype.constructor = MoviePlayerRegistryManagerBroker;
MoviePlayerRegistryManagerBroker.superclass = Broker.prototype;
function MoviePlayerRegistryManagerBroker()
{
}
MoviePlayerRegistryManagerBroker.prototype.addActivatedHandle = function(action)
{
	;
	this.registerAction("activated", action);
}
MoviePlayerRegistryManagerBroker.prototype.activated = function()
{
	;
	
	this.getMessage("activated");
}
