/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Globals</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
    <DEPENDS>Domlet</DEPENDS>
    <DEPENDS>Point</DEPENDS>
</DEPENDENCIES>
*/
ProductInfoViewable.prototype = new DomletCtr();
ProductInfoViewable.prototype.constructor = ProductInfoViewable;
ProductInfoViewable.superclass = DomletCtr.prototype;
function ProductInfoViewable(sId, sWidgetDomId, heightOffset, sCoverDomId)
{
	if (sId,sWidgetDomId)
	{
		this.init(sId, sWidgetDomId, heightOffset, sCoverDomId);
	}
}
ProductInfoViewable.prototype.init = function(sId, sWidgetDomId, heightOffset, sCoverDomId)
{
	;
	var me = this;
	this.sId = sId;
	this.select = false;
	this.product = null;
	this.blocked = false;
	this.loaded = false;
	this.values = new Array();
	this.defaultValues = new Array();
	this.visible = true;
	this.selectedHandler = new Array();
	this.unselectedHandler = new Array();
	this.heightOffset = heightOffset;
	this.widget = Browser.getElementById(sWidgetDomId);
	ProductInfoViewable.superclass.init.call(this, sWidgetDomId, sId, null);
	this.addDomlet(new Domlet(
			this.widget.id, 
			this.name, 
			this.parent, 
			new Array("mousedown")) 
			)
	this.coverDomId = sCoverDomId;
	this.nCover = Browser.getElementById(sCoverDomId);
	
	this.mouseUpHandler = function(e)
	{
		;
		if (e)
		{
			var event = e;
		}
		Browser.removeEventListenerFromDocument(Browser.eventNames.MOUSEMOVE, me.mouseMoveHandler);
		Browser.removeEventListenerFromDocument(Browser.eventNames.MOUSEUP, me.mouseUpHandler);
		Browser.removeEventListenerFromDocument(Browser.eventNames.MOUSEOUT, me.mouseOutHandler);
		if (me.inMouseMove)
		{
			me.inMouseMove = false;
			me.endDrag();
		}
		return false;
	}
	this.mouseMoveHandler = function(e)
	{
		;
		if (e)
		{
			var event = e;
		}
		if (!me.inMouseMove)
		{
			if (Math.abs(event.clientX - me.mouseDownX) > 2 || Math.abs(event.clientY - me.mouseDownY) > 2)
			{
				me.inMouseMove = true;
				me.beginDrag(event);
				me.lostDeltaX = event.clientX - me.mouseDownX;
				me.lostDeltaY = event.clientY - me.mouseDownY;
			}
		}
		return false;
	}
	this.mouseOutHandler = function(event)
	{
		;
		
		if (Browser.getId() == 'moz')
		{
			if (event.explicitOriginalTarget.nodeName == 'HTML')
			{
				me.mouseUpHandler(event);
			}
		}
		else
		{
			if (event.srcElement.tagName == 'BODY')
			{
				me.mouseUpHandler(event);
			}
		}
		
		
	}
	this.mouseDoubleClickHandler = function(e)
	{
		;
		if (e)
		{
			var event = e;
			DynamicDataLoader.instance.showDeeplink(me.product);
		}
		return false;
	}
	this.mouseClickHandler = function(e)
	{
		if (e)
		{
			me.selected();
		}
		return false;
	}
	
	Browser.addEventListenerToDomNode(this.widget, Browser.eventNames.DOUBLECLICK, this.mouseDoubleClickHandler);
	Browser.addEventListenerToDomNode(this.widget, Browser.eventNames.CLICK, this.mouseClickHandler);
}
ProductInfoViewable.prototype.getId = function()
{
	return this.sId;
}
ProductInfoViewable.prototype.setManager = function(manager)
{
	this.manager = manager;
}
ProductInfoViewable.prototype.registerTextValue = function(property, action, defaultValue)
{
	if (defaultValue == undefined || defaultValue == null)
		this.defaultValues[property] = "-";
	else
		this.defaultValues[property] = defaultValue;
	this.values[property] = action;
}
ProductInfoViewable.prototype.registerImageValue = function(property, action, defaultImage)
{
	if (defaultImage == undefined || defaultImage == null)
	{
		;
		this.defaultValues[property] = "error.gif";
	}
	else
		this.defaultValues[property] = defaultImage;
	this.values[property] = action;
}
ProductInfoViewable.prototype.cover = function()
{
	if (this.nCover && this.visible)
	{
		this.nCover.style.visibility = "visible";
	}
}
ProductInfoViewable.prototype.uncover = function()
{
	if (this.nCover)
	{
		this.nCover.style.visibility = "hidden";
	}
}
ProductInfoViewable.prototype.setInfoVisible = function(visible)
{
	this.visible = visible;
	this.setVisible(visible);
}
ProductInfoViewable.prototype.setModel = function(product)
{
	if (this.blocked == true)
	{
		this.blockedProduct = product;
	}
	else
	{
		this.changed(product);
	}
}
ProductInfoViewable.prototype.getModel = function()
{
	return this.product;
}
ProductInfoViewable.prototype.refresh = function()
{
	
	this.setModel(this.blockedProduct);
}
ProductInfoViewable.prototype.setModelItem = function(product)
{
	
	
}
ProductInfoViewable.prototype.changed = function(product)
{
	this.blocked = true;
	this.blockedProduct = product;
	var process = true;
	if (process == true)
	{
		this.product = product;
		if (product == null)
		{
			this.setInfoVisible(false);
			this.loaded = false;
		}
		else
		{
			this.loaded = product.isLoaded();
		}
		if (product != null && this.visible == false)
			this.setInfoVisible(true);
		for (property in this.values)
		{
			var action = this.values[property];
			var value = null;
			if (this.product)
				value = this.product[property];
			if (value == null || value == undefined)
				value = this.defaultValues[property];
			var params = new Array();
			params[0] = value;
			action.invoke(params);
		}
		if (this.product != null && this.select == true)
			this.selected();
	}
	
	if (this.product != this.blockedProduct)
	{
		var unblock = this.blockedProduct;
		this.changed(unblock);
	}
	this.blocked = false;
}
ProductInfoViewable.prototype.beginDrag = function(event)
{
	if (this.product != null)
	{
		var screenPos = new Point(0, 0);
		Browser.getScreenPos(this.widget, screenPos);
		var point = new Point(screenPos.x, screenPos.y - this.heightOffset);
		this.manager.startDragAndDrop(this.product,
				point, event);
	}
}
ProductInfoViewable.prototype.endDrag = function()
{
	
}
ProductInfoViewable.prototype.eventFromChild = function(childName, eventType, event)
{
	var domlet = this.domlets[childName];
	switch (eventType)
			{
		case "mousedown" :
			;
			this.mouseDownHandler(domlet, event);
			break;
		case "mouseup" :
			;
		
			break;
		case "mouseover" :
			;
			break;
		case "mouseout" :
			;
			break;
		case "mousemove" :
		//;
		
			break;
		case "click" :
			;
			break;
	}
}
ProductInfoViewable.prototype.mouseDownHandler = function(domlet, event)
{
	if (this.inMouseMove)
	{
		this.mouseUpHandler(event);
	}
	else
	{
		Browser.eventStopPropagation(event);
		Browser.eventPreventDefault(event);
		this.inMouseMove = false;
		this.mouseDownX = event.clientX;
		this.mouseDownY = event.clientY;
		Browser.addEventListenerToDocument(Browser.eventNames.MOUSEMOVE, this.mouseMoveHandler);
		Browser.addEventListenerToDocument(Browser.eventNames.MOUSEUP, this.mouseUpHandler);
		Browser.addEventListenerToDocument(Browser.eventNames.MOUSEOUT, this.mouseOutHandler);
		return false;
	}
}
ProductInfoViewable.prototype.getShowDeepLinkAction = function()
{
	return new ObjectMethodAction(this, 'showDeepLink');
}
ProductInfoViewable.prototype.showDeepLink = function()
{
	DynamicDataLoader.instance.showDeeplink(this.product);
}
ProductInfoViewable.prototype.getSelectAction = function()
{
	return new ObjectMethodAction(this, 'selected');
}
ProductInfoViewable.prototype.selected = function()
{
	if (this.product == null)
	{
		this.select = true;
	}
	else
	{
		this.select = false;
		this.manager.selected(this);
		for (var i = 0; i < this.selectedHandler.length; i++)
		{
			this.selectedHandler[i].invoke();
		}
	}
}
ProductInfoViewable.prototype.registerSelectedHandler = function(action)
{
	this.selectedHandler.push(action);
}
ProductInfoViewable.prototype.unSelected = function()
{
	this.select = false;
	this.manager.unSelected(this);
	for (var i = 0; i < this.unselectedHandler.length; i++)
	{
		this.unselectedHandler[i].invoke();
	}
}
ProductInfoViewable.prototype.registerUnSelectedHandler = function(action)
{
	this.unselectedHandler.push(action);
}
