/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Dragable</DEPENDS>
</DEPENDENCIES>
*/
DnDProductDragable.prototype = new Dragable();
DnDProductDragable.prototype.constructor = DnDProductDragable;
DnDProductDragable.superclass = Dragable.prototype;
function DnDProductDragable( sId, sWidgetDomId, nHotSpotX, nHotSpotY, sWidgetLug, droptarget )
{
  if( sId )
  {
    this.init(sId, sWidgetDomId, nHotSpotX, nHotSpotY, sWidgetLug, droptarget);
  }
}
DnDProductDragable.prototype.init = function( sId, sWidgetDomId, nHotSpotX, nHotSpotY, sWidgetLug, droptarget )
{
  ;
  DnDProductDragable.superclass.init.call(this, sId, sWidgetDomId, nHotSpotX, nHotSpotY, sWidgetLug);
  var me = this;
  this.product = null;
  this.broker = null;
  this.dropTarget = droptarget;
  this.values = new Array();
  this.defaultValues = new Array();
  this.dropPos = null;
  this.enabled = true;
  this.mouseUpHandler = function( e )
  {
    ;
    if( e )
    {
      var event = e;
    }
    Browser.removeEventListenerFromDocument(Browser.eventNames.MOUSEMOVE, me.mouseMoveHandler);
    Browser.removeEventListenerFromDocument(Browser.eventNames.MOUSEUP, me.mouseUpHandler);
    Browser.removeEventListenerFromDocument(Browser.eventNames.MOUSEOUT, me.mouseOutHandler);
    me.inMouseMove = false;
    me.dropPos = new Point(event.clientX, event.clientY);
    me.endDrag();
    return false;
  }
}
DnDProductDragable.prototype.setMainManager = function( mainManager )
{
  this.mainManager = mainManager;
}
DnDProductDragable.prototype.getManagerName = function()
{
  return this.sId;
}
DnDProductDragable.prototype.setModelItem = function( product )
{
  this.product = product;
  this.changed(product);
}
DnDProductDragable.prototype.getModelItem = function()
{
  return this.product;
}
DnDProductDragable.prototype.enable = function()
{
  this.enabled = true;
}
DnDProductDragable.prototype.getEnableAction = function()
{
  return new ObjectMethodAction(this, "enable");
}
DnDProductDragable.prototype.disable = function()
{
  this.enabled = false;
}
DnDProductDragable.prototype.getDisableAction = function()
{
  return new ObjectMethodAction(this, "disable");
}
DnDProductDragable.prototype.isOwner = function( productId )
{
  if( this.product == null )
    return false;
  if( this.product.getProductId() == productId )
    return true;
  return false;
}
DnDProductDragable.prototype.beginDragFromOutside = function( event )
{
  if( this.enabled )
    this.mouseDownHandler(this.dragWidget, event);
}
DnDProductDragable.prototype.setBroker = function( broker )
{
  ;
  this.broker = broker;
}
DnDProductDragable.prototype.changed = function( model )
{
}
DnDProductDragable.prototype.getPos = function()
{
  var point = new Point(0, 0);
  Browser.getScreenPos(this.dragWidget, point);
  return point;
}
DnDProductDragable.prototype.drop = function( oDropTarget, bDropped )
{
  if( bDropped )
  {
    this.setVisible(false);
  }
  else
  {
    this.moveToHomePosition();
    this.dropTarget = null;
  }
}
DnDProductDragable.prototype.moveToHomePosition = function()
{
  DnDProductDragable.superclass.moveToHomePosition.call(this);
  var product = this.product;
  this.product = null;
  this.mainManager.abortDragAndDrop(product);
  this.setVisible(false);
}
DnDProductDragable.prototype.registerTextValue = function( property, action, defaultValue )
{
  if( defaultValue == undefined || defaultValue == null )
    this.defaultValues[property] = "-";
  else
    this.defaultValues[property] = defaultValue;
  this.values[property] = action;
}
DnDProductDragable.prototype.registerImageValue = function( property, action, defaultImage )
{
  if( defaultImage == undefined || defaultImage == null )
  {
    ;
    this.defaultValues[property] = "error.gif";
  }
  else
    this.defaultValues[property] = defaultImage;
  this.values[property] = action;
}
DnDProductDragable.prototype.changed = function( product )
{
  ;
  this.product = product;
  for( property in this.values )
  {
    var action = this.values[property];
    var value = null;
    if( this.product )
      value = this.product[property];
    if( value == null || value == undefined )
      value = this.defaultValues[property];
    var params = new Array();
    params[0] = value;
    action.invoke(params);
  }
}
