/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Globals</DEPENDS>
    <DEPENDS>BasicQeaCorrectionStrategy</DEPENDS>
</DEPENDENCIES>
*/
LastAssignmentQeaCorrectionStrategy.prototype             = new BasicQeaCorrectionStrategy();
LastAssignmentQeaCorrectionStrategy.prototype.constructor = LastAssignmentQeaCorrectionStrategy;
LastAssignmentQeaCorrectionStrategy.superclass            = BasicQeaCorrectionStrategy.prototype;
function LastAssignmentQeaCorrectionStrategy(sId, nRemoveWrongTime, bShowCorrect, nShowCorrectTime)
{
  this.init(sId, nRemoveWrongTime, bShowCorrect, nShowCorrectTime)
}
LastAssignmentQeaCorrectionStrategy.prototype.init = function(sId, nRemoveWrongTime, bShowCorrect, nShowCorrectTime)
{
  ;
  this.nRemoveWrongTime = nRemoveWrongTime;
  this.nShowCorrectTime = nShowCorrectTime;
  this.bShowCorrect = bShowCorrect;
  this.nHandles = 0;
  LastAssignmentQeaCorrectionStrategy.superclass.init.call(this, sId);
}
LastAssignmentQeaCorrectionStrategy.prototype.showCorrection = function()
{
  ;
  var lastEvaluation = this.getLastEvaluation();
  if(lastEvaluation)
  {
    var sHandleId = this.sId + '_' + this.nHandles++;
    var oHandle = new LastAssignmentQeaCorrectionStrategyHandle(sHandleId, this, lastEvaluation);
    oHandle.showCorrection();
  }
}
var staticLastAssignmentQeaCorrectionStrategyHandle = new Array();
LastAssignmentQeaCorrectionStrategyHandle_getInstance = function(sId)
{
  var Instance = null;
  if ( staticLastAssignmentQeaCorrectionStrategyHandle[sId] )
  {
    Instance = staticLastAssignmentQeaCorrectionStrategyHandle[sId];
  }
  return Instance;
}
function LastAssignmentQeaCorrectionStrategyHandle(sId, strategy, lastEvaluation)
{
  this.init(sId, strategy, lastEvaluation);
}
LastAssignmentQeaCorrectionStrategyHandle.prototype.init = function(sId, strategy, lastEvaluation)
{
  ;
  this.sId = sId;
  this.strategy = strategy;
  this.lastEvaluation = lastEvaluation;
  this.aTimerEvaluations = new Array();
  staticLastAssignmentQeaCorrectionStrategyHandle[sId] = this;
}
LastAssignmentQeaCorrectionStrategyHandle.prototype.hasCorrection = function()
{
  ;
  var bHasCorrection = true;
  if (! (bHasCorrection && this.lastEvaluation))
  {
    bHasCorrection = false;
  }
  return bHasCorrection;
}
LastAssignmentQeaCorrectionStrategyHandle.prototype.showCorrection = function()
{
  ;
  var lastEvaluation = null;
  if (this.hasCorrection())
  {
    lastEvaluation = this.lastEvaluation;
  }
  if ( lastEvaluation )
  {
    if ( lastEvaluation.isCorrect() )
    {
      if ( lastEvaluation.isActive() )
      {
        var bSystemConstructive = lastEvaluation.bSystemConstructive;
        lastEvaluation.setActive(true, 'system_approve');
        lastEvaluation.bSystemConstructive = bSystemConstructive;
        lastEvaluation.workItem.changed(lastEvaluation);
        this.lastTippedEvaluation = lastEvaluation;
      }
      else
      {
      }
    }
    else
    {
      if( lastEvaluation.isActive() )
      {
        this.strategy.exerciseManager.beginCorrection();
        var bSystemConstructive = lastEvaluation.bSystemConstructive;
        lastEvaluation.setSilentlyActive(true, 'system_brand');
        lastEvaluation.bSystemConstructive = bSystemConstructive;
        lastEvaluation.workItem.changed(lastEvaluation);
        this.aTimerEvaluations.push(lastEvaluation);
        this.lastTippedEvaluation = lastEvaluation;
        window.setTimeout('LastAssignmentQeaCorrectionStrategyHandle_getInstance(\''+this.sId+'\').removeWrong();', this.strategy.nRemoveWrongTime);
      }
      else
      {
      }
    }
  }
}
LastAssignmentQeaCorrectionStrategyHandle.prototype.removeWrong = function()
{
  ;
  var evaluation = this.aTimerEvaluations.pop();
  evaluation.setActive(false, 'system_set');
  if( this.strategy.bShowCorrect )
  {
    var question = evaluation.getQuestion();
    var solutionEvaluation = this.strategy.findTippableEvaluation(question);
    if ( solutionEvaluation != null )
    {
      this.aTimerEvaluations.push(solutionEvaluation);
      window.setTimeout('LastAssignmentQeaCorrectionStrategyHandle_getInstance(\''+this.sId+'\').showCorrect();', this.strategy.nShowCorrectTime);
    }
  }
  else
  {
    this.strategy.exerciseManager.endCorrection();
  }
}
LastAssignmentQeaCorrectionStrategyHandle.prototype.showCorrect = function()
{
  ;
  var evaluation = this.aTimerEvaluations.pop();
  evaluation.setActive(true, 'system_approve');
  this.lastTippedEvaluation = evaluation;
  this.strategy.exerciseManager.endCorrection();
}
