/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Globals</DEPENDS>
    <DEPENDS>ObjectMethodAction</DEPENDS>
</DEPENDENCIES>
*/
function MultipleTrialsObserver(sId, nTrials)
{
  if (sId) this.init(sId, nTrials);
}
MultipleTrialsObserver.prototype.init = function(sId, nTrials)
{
  ;
  this.sId = sId;
  this.oMarkAction = null;
  this.oMarkAndCorrectAction = null;
  this.oDoneAction = null;
  this.bCorrectionInvoked = false;
  this.broker = null;
  if(nTrials)
  {
    this.nTrials = nTrials;
  }
  else
  {
    this.nTrials = 1;
  }
}
MultipleTrialsObserver.prototype.setMarkAction = function(markAction)
{
  this.oMarkAction = markAction;
}
MultipleTrialsObserver.prototype.setDoneAction = function(action)
{
  this.oDoneAction = action;
}
MultipleTrialsObserver.prototype.setBroker = function(multipleTrialsObserverBroker)
{
  this.broker = multipleTrialsObserverBroker;
}
MultipleTrialsObserver.prototype.statusChanged = function(status)
{
  ;
  if(!this.bCorrectionInvoked)
  {
    ;
    this.bCorrectionInvoked = true;
    if((status.nWrongStatus > 0) || (status.nCorrectStatus > 0))
    {
      if(this.oMarkAction)
      {
        this.oMarkAction.invoke();
      }
      if(status.nWrongStatus > 0)
      {
        if(this.broker)
        {
          this.broker.reachedTrial(status.nWrongStatus);
        }
      }
      if((status.nCorrectStatus + status.nCorrectSystem) >= status.nCorrect)
      {
        if(this.oDoneAction)
        {
          this.oDoneAction.invoke();
        }
      }
      if(status.nWrongStatus >= this.nTrials)
      {
        if(this.oDoneAction)
        {
          this.oDoneAction.invoke();
        }
      }
    }
    this.bCorrectionInvoked = false;
  }
}
MultipleTrialsObserver.prototype.getStatusAction = function()
{
  return new ObjectMethodAction(this, 'statusChanged');
}
