/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Globals</DEPENDS>
</DEPENDENCIES>
*/
function BasicQeaCorrectionStrategy(sId)
{
  if (sId) this.init(sId);
}
BasicQeaCorrectionStrategy.prototype.init = function(sId)
{
  ;
  this.sId = sId;
  this.exerciseManager = null;
  this.lastTippedEvaluation = null;
}
BasicQeaCorrectionStrategy.prototype.getId = function()
{
  return this.sId;
}
BasicQeaCorrectionStrategy.prototype.setExerciseManager = function(exerciseManager)
{
  ;
  this.exerciseManager = exerciseManager;
}
BasicQeaCorrectionStrategy.prototype.start = function()
{
  ;
}
BasicQeaCorrectionStrategy.prototype.hasCorrection = function()
{
  ;
  var bHasCorrection = false;
  return bHasCorrection;
}
BasicQeaCorrectionStrategy.prototype.showCorrection = function()
{
  ;
  var lastEvaluation = null;
  if (this.hasCorrection())
  {
    lastEvaluation = this.getLastEvaluation();
  }
  if ( lastEvaluation )
  {
    lastEvaluation.setActive(false, 'system_correction');
    this.lastTippedEvaluation = lastEvaluation;
  }
}
BasicQeaCorrectionStrategy.prototype.getLastWorkItem = function()
{
  ;
  var lastWorkItem = null;
  if( this.exerciseManager )
  {
    if ( this.exerciseManager.currentExecHandler )
    {
      lastWorkItem = this.exerciseManager.currentExecHandler;
    }
  }
  return lastWorkItem;
}
BasicQeaCorrectionStrategy.prototype.getLastEvaluation = function()
{
  ;
  var lastEvaluation = null;
  if ( this.getLastWorkItem() )
  {
    if ( this.getLastWorkItem().lastUserActivatedEvaluation )
    {
      lastEvaluation = this.getLastWorkItem().lastUserActivatedEvaluation;
    }
  }
  return lastEvaluation;
}
BasicQeaCorrectionStrategy.prototype.getShowCorrectionAction = function()
{
  ;
  return new ObjectMethodAction(this, "showCorrection");
}
BasicQeaCorrectionStrategy.prototype.findTippableEvaluation = function(question)
{
  var oWorkItem = this.getLastWorkItem();
  var aEvaluations = oWorkItem.aEvaluations;
  var bHasTip = true;
  if (bHasTip)
  {
    if (question.getMax() == 1) 
    {
      if (question.countActiveEvaluations() > 0)
      {
        bHasTip = false;
      }
    }
  }
  if (bHasTip)
  {
    for(var i in aEvaluations)
    {
      var evaluation = aEvaluations[i];
      if(evaluation.getQuestion() == question)
      {
        if(this.evaluationHasTip(evaluation))
        {
          return evaluation;
        }
      }
    }
  }
}
BasicQeaCorrectionStrategy.prototype.evaluationHasTip = function(evaluation)
{
  ;
  var bHasTip = true;
  if (bHasTip)
  {
    bHasTip = evaluation.isSolution() && !evaluation.isActive();
  }
  if (bHasTip)
  {
    bHasTip = !evaluation.hasOffItem();
  }
  if (bHasTip)
  {
    bHasTip = evaluation.canSetActive(true);
  }
  if (bHasTip)
  {
    if (evaluation.getQuestion().getMax() == 1) 
    {
      if (evaluation.getQuestion().countActiveEvaluations() > 0)
      {
        bHasTip = false;
      }
    }
  }
  if (bHasTip)
  {
    if (evaluation.getAnswer().getMax() == 1) 
    {
      if (evaluation.getAnswer().countActiveEvaluations() > 0)
      {
        bHasTip = false;
      }
    }
  }
  return bHasTip;
}
