/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Broker</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
</DEPENDENCIES>
*/
function ComprehensionManager(sId)
{
    this.init(sId)
}
ComprehensionManager.prototype.init = function(sId)
{
  ;
  this.sId = sId;
  this.aContents = new Array();
  this.oComprehensionBroker = null;
  this.bCompletelyConsumed = false;
  this.reset();
}
ComprehensionManager.prototype.setComprehensionBroker = function(comprehensionBroker)
{
  this.oComprehensionBroker = comprehensionBroker;
}
ComprehensionManager.prototype.registerContent = function(contentId)
{
  this.aContents[contentId] = false;
  ;
  return new ObjectMethodAction(this, 'contentConsumed', contentId);
}
ComprehensionManager.prototype.contentConsumed = function(contentId)
{
  this.aContents[contentId] = true;
  ;
  this.checkCompletelyConsumed();
}
ComprehensionManager.prototype.checkCompletelyConsumed = function()
{
  if(!this.bCompletelyConsumed)
  {
    for(var id in this.aContents)
    {
      if(this.aContents[id])
      {
        this.bCompletelyConsumed = true;
      }
    }
    if(this.bCompletelyConsumed && this.oComprehensionBroker)
    {
      this.oComprehensionBroker.doContentConsumed();
    }
  }
}
ComprehensionManager.prototype.reset = function()
{
  this.bCompletelyConsumed = false;
  for(var id in this.aContents)
  {
    this.aContents[id] = false;
  }
}
ComprehensionManager.prototype.getResetAction = function()
{
  return new ObjectMethodAction(this, 'reset');
}
