/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Globals</DEPENDS>
    <DEPENDS>BasicQeaTipStrategy</DEPENDS>
</DEPENDENCIES>
*/
ShowCharHighlighterTipStrategy.prototype             = new ShowMissingQeaTipStrategy();
ShowCharHighlighterTipStrategy.prototype.constructor = ShowCharHighlighterTipStrategy;
ShowCharHighlighterTipStrategy.superclass            = ShowMissingQeaTipStrategy.prototype;
function ShowCharHighlighterTipStrategy(sId, bJustUserSelect)
{
  this.init(sId, bJustUserSelect)
}
ShowCharHighlighterTipStrategy.prototype.init = function(sId, bJustUserSelect)
{
  this.bJustUserSelect = bJustUserSelect;
  ShowCharHighlighterTipStrategy.superclass.init.call(this, sId);
}
ShowCharHighlighterTipStrategy.prototype.hasShowTip= function(bShow, bStepByStep, bSolutable, bCycleTips)
{
  this.aStatus = new Array();
  for ( var i in this.workItem.aEvaluations)
  {
    var oEvaluation = this.workItem.aEvaluations[i];
    if ( oEvaluation.isActive() )
    {
      var oAnswer = oEvaluation.getAnswer();
      if ( oAnswer.isAnswer() == 'Highlighter Answer' && ! oEvaluation.hasOffItem())
      {
        for ( var j = oAnswer.getStartPos(); j < oAnswer.getStartPos() + oAnswer.getLength(); j++)
        {
          this.aStatus[j] = oEvaluation;
        }
      }
    }
  }
  ;
  var bHasTip = false;
  var aTippableEvaluations = new Array();
  var nIndex = 0;
  var bIsLastAnswerCorrect = true;
  var lastAnswer = null;
  if (this.lastEvaluation != null)
  {
    var lastAnswer = this.lastEvaluation.getAnswer();
    bIsLastAnswerCorrect = (lastAnswer.countActiveCorrectEvaluations() > 0);
  }
  for (var id in this.workItem.aEvaluations)
  {
    var e = this.workItem.aEvaluations[id];
    if ( ! bIsLastAnswerCorrect )
    {
      if ( e.getAnswer() != lastAnswer)
      {
        continue;
      }
    }
    if (this.evaluationHasTip(e, bStepByStep, bCycleTips))
    {
      aTippableEvaluations[nIndex++] = e;
    }
  }
  if ( nIndex > 0)
  {
    ;
    bHasTip = true;
  }
  if (bShow && bHasTip)
  {
    shuffleArray(aTippableEvaluations);
    var e = aTippableEvaluations[0];
    this.evaluationShowTip(e, bStepByStep, bCycleTips);
    this.lastEvaluation = e;
  }
  return bHasTip;
}
ShowCharHighlighterTipStrategy.prototype.evaluationHasTip = function(evaluation, bStepByStep, bCycleTips)
{
  var bHasTip = true;
  if (this.bJustUserSelect && bHasTip)
  {
    bHasTip = this.workItem.isCurrentWorkItem();
  }
  if(bHasTip)
  {
    if(bCycleTips)
    {
      return this.evaluationHasCycleTip(evaluation, bStepByStep);
    }
    else
    {
      return this.evaluationHasNonCycleTip(evaluation, bStepByStep);
    }
  }
  return bHasTip;
}
ShowCharHighlighterTipStrategy.prototype.evaluationShowTip = function(evaluation, bStepByStep, bCycleTips)
{
  var bHasTip = true;
  if (this.bJustUserSelect && bHasTip)
  {
    bHasTip = this.workItem.isCurrentWorkItem();
  }
  if(bHasTip)
  {
    if(bCycleTips)
    {
      return this.evaluationShowCycleTip(evaluation, bStepByStep);
    }
    else
    {
      return this.evaluationShowNonCycleTip(evaluation, bStepByStep);
    }
  }
  return bHasTip;
}
ShowCharHighlighterTipStrategy.prototype.evaluationHasCycleTip = function(evaluation, bStepByStep)
{
  ;
  var bHasTip = true;
  if (bHasTip)
  {
    bHasTip = evaluation.isSolution() && !evaluation.isActive();
  }
  if (bHasTip)
  {
    bHasTip = !evaluation.hasOffItem();
  }
  if (bHasTip)
  {
    bHasTip = evaluation.canSetActive(true);
  }
  if (bHasTip)
  {
    if (evaluation.getQuestion().getMax() == 1) 
    {
      if (evaluation.getQuestion().countActiveEvaluations() > 0)
      {
        bHasTip = false;
      }
    }
  }
  if (bHasTip)
  {
    if (evaluation.getAnswer().getMax() == 1) 
    {
      if (evaluation.getAnswer().countActiveEvaluations() > 0)
      {
        bHasTip = false;
      }
    }
  }
  return bHasTip;
}
ShowCharHighlighterTipStrategy.prototype.evaluationShowCycleTip = function(evaluation, bStepByStep)
{
  ;
  var aValidTips = new Array();
  var aCopyOfStatus = new Array();
  aCopyOfStatus = this.aStatus;
  var oAnswer = evaluation.getAnswer();
  for ( var i = oAnswer.getStartPos(); i < oAnswer.getStartPos() + oAnswer.getLength(); i++)
  {
    if ( aCopyOfStatus.length )
    {
      if ( aCopyOfStatus[i] )
      {
        aCopyOfStatus[i].setActive(false);
      }
      else
      {
        aValidTips.push(i);
      }
    }
    else
    {
      aValidTips.push(i);
    }
  }
  var nTipAnswerStart = null;
  var nLow = 0;
  if ( ! aValidTips.length )
  {
    for ( var i = oAnswer.getStartPos() + 1 ; i < oAnswer.getStartPos() + oAnswer.getLength(); i++)
    {
      aValidTips.push(i);
    }
  }
  var nHigh = aValidTips.length - 1;
  nTipAnswerStart = Math.round( (nLow - 0.5) +( ( (nHigh+0.49999) - (nLow-0.5) ) * Math.random() ) );
  nTipAnswerStart = aValidTips[nTipAnswerStart];
  var oTipAnswer = null;
  oTipAnswer = this.workItem.getAnswerByPosAndLength(nTipAnswerStart, 1);
  if ( ! oTipAnswer )
  {
    ;
  }
  else
  {
    var oTipEvaluation = this.workItem.getEvaluation( evaluation.getQuestion(), oTipAnswer);
    oTipEvaluation.setActive(true, 'system_set');
  }
}
ShowCharHighlighterTipStrategy.prototype.evaluationHasNonCycleTip = function(evaluation, bStepByStep)
{
  ;
  var bHasTip = true;
  if (bHasTip)
  {
    bHasTip = evaluation.isSolution() && !evaluation.isActive();
  }
  if (bHasTip)
  {
    bHasTip = !evaluation.hasOffItem();
  }
  if (bHasTip)
  {
    bHasTip = evaluation.canSetActive(true);
  }
  if (bHasTip)
  {
    if (evaluation.getQuestion().getMax() == 1) 
    {
      if (evaluation.getQuestion().countActiveEvaluations() > 0)
      {
        bHasTip = false;
      }
    }
  }
  if (bHasTip)
  {
    if (evaluation.getAnswer().getMax() == 1) 
    {
      if (evaluation.getAnswer().countActiveEvaluations() > 0)
      {
        bHasTip = false;
      }
    }
  }
  if (bHasTip)
  {
    var oAnswer = evaluation.getAnswer();
    for ( i = oAnswer.getStartPos(); i <= oAnswer.getStartPos() + oAnswer.getLength(); i++)
    {
      if ( this.aStatus[i] && ! this.aStatus[i].hasSystemContribution())
      {
        bHasTip = false;
        break;
      }
    }
  }
  return bHasTip;
}
ShowCharHighlighterTipStrategy.prototype.evaluationShowNonCycleTip = function(evaluation, bStepByStep)
{
  ;
  var aValidTips = new Array();
  var oAnswer = evaluation.getAnswer();
  for ( var i = oAnswer.getStartPos(); i < oAnswer.getStartPos() + oAnswer.getLength(); i++)
  { 
    if ( this.aStatus.length )
    {
      if ( ! this.aStatus[i] || this.aStatus.hasSystemContribution)
      {
        aValidTips.push(i);
      }
    }
    else
    {
      aValidTips.push(i);
    }
  }
  var nTipAnswerStart = null;
  if ( aValidTips.length == 1)
  {
    var aCopyOfStatus = new Array();
    aCopyOfStatus = this.aStatus;
    for ( var i = oAnswer.getStartPos(); i < oAnswer.getStartPos() + oAnswer.getLength(); i++)
    { 
      if( aCopyOfStatus[i] )
      {
        aCopyOfStatus[i].setActive(false, 'system_set');
      }
    }
    evaluation.setActive(true, 'system_set');
  }
  else
  {
    var nLow = 0;
    if ( ! aValidTips.length )
    {
      for ( var i = oAnswer.getStartPos() + 1 ; i < oAnswer.getStartPos() + oAnswer.getLength(); i++)
      {
        aValidTips.push(i);
      }
    }
    var nHigh = aValidTips.length - 1;
    nTipAnswerStart = Math.round( (nLow - 0.5) +( ( (nHigh+0.49999) - (nLow-0.5) ) * Math.random() ) );
    nTipAnswerStart = aValidTips[nTipAnswerStart];
    var oTipAnswer = null;
    oTipAnswer = this.workItem.getAnswerByPosAndLength(nTipAnswerStart, 1);
    if ( ! oTipAnswer )
    {
      ;
    }
    else
    {
      var oTipEvaluation = this.workItem.getEvaluation( evaluation.getQuestion(), oTipAnswer);
      oTipEvaluation.setActive(true, 'system_set');
    }
  }
}
RemoveWrongHighlighterTipStrategy.prototype             = new ShowCharHighlighterTipStrategy();
RemoveWrongHighlighterTipStrategy.prototype.constructor = RemoveWrongHighlighterTipStrategy;
RemoveWrongHighlighterTipStrategy.superclass            = ShowCharHighlighterTipStrategy.prototype;
function RemoveWrongHighlighterTipStrategy(sId, bJustUserSelect)
{
  this.init(sId, bJustUserSelect)
}
RemoveWrongHighlighterTipStrategy.prototype.init = function(sId, bJustUserSelect)
{
  this.bJustUserSelect = bJustUserSelect;
  ShowCharHighlighterTipStrategy.superclass.init.call(this, sId);
}
RemoveWrongHighlighterTipStrategy.prototype.hasShowTip= function(bShow, bStepByStep, bSolutable, bCycleTips)
{
  ;
  var bHasTip = false;
  var aTippableEvaluations = new Array();
  var nIndex = 0;
  var bIsLastAnswerCorrect = true;
  var lastAnswer = null;
  for (var id in this.workItem.aEvaluations)
  {
    var e = this.workItem.aEvaluations[id];
    if (this.evaluationHasTip(e, bStepByStep))
    {
      aTippableEvaluations[nIndex++] = e;
    }
  }
  if ( nIndex > 0)
  {
    ;
    bHasTip = true;
  }
  if (bShow && bHasTip)
  {
    shuffleArray(aTippableEvaluations);
    var e = aTippableEvaluations[0];
    this.evaluationShowTip(e, bStepByStep);
  }
  return bHasTip;
}
RemoveWrongHighlighterTipStrategy.prototype.evaluationHasTip = function(evaluation, bStepByStep)
{
  ;
  var bHasTip = true;
  if (this.bJustUserSelect && bHasTip)
  {
    bHasTip = this.workItem.isCurrentWorkItem();
  }
  if (bHasTip)
  {
    ;
    bHasTip = !evaluation.isCorrect() && evaluation.isActive() && ! evaluation.hasSystemContribution();
  }
  return bHasTip;
}
RemoveWrongHighlighterTipStrategy.prototype.evaluationShowTip = function(evaluation, bStepByStep)
{
  ;
  evaluation.setActive(false, 'system_unset');
}
ShowCharHighlighterOnSelectedTipStrategy.prototype             = new ShowCharHighlighterTipStrategy();
ShowCharHighlighterOnSelectedTipStrategy.prototype.constructor = ShowCharHighlighterOnSelectedTipStrategy;
ShowCharHighlighterOnSelectedTipStrategy.superclass            = ShowCharHighlighterTipStrategy.prototype;
function ShowCharHighlighterOnSelectedTipStrategy(sId)
{
  this.init(sId, true)
}
RemoveWrongHighlighterOnSelectedTipStrategy.prototype             = new RemoveWrongHighlighterTipStrategy();
RemoveWrongHighlighterOnSelectedTipStrategy.prototype.constructor = RemoveWrongHighlighterOnSelectedTipStrategy;
RemoveWrongHighlighterOnSelectedTipStrategy.superclass            = RemoveWrongHighlighterTipStrategy.prototype;
function RemoveWrongHighlighterOnSelectedTipStrategy(sId)
{
  this.init(sId, true)
}
