/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
    <DEPENDS>Domlet</DEPENDS>
</DEPENDENCIES>
*/
Memory.prototype             = new DomletCtr();
Memory.prototype.constructor = Memory;
Memory.superclass            = DomletCtr.prototype;
function Memory(sId, sWidgetCoveredDomId, sWidgetUncoveredDomId, sBorderColorCorrect)
{
  if (sId) { this.init(sId, sWidgetCoveredDomId, sWidgetUncoveredDomId, sBorderColorCorrect); }
}
Memory.prototype.init = function(sId, sWidgetCoveredDomId, sWidgetUncoveredDomId, sBorderColorCorrect)
{
  ;
  this.sId = sId;
  this.modelItem = null;
  this.sBorderColorCorrect = null;
  this.bClickable = true;
  Memory.superclass.init.call(this, sWidgetUncoveredDomId, sId, this);
  if (sBorderColorCorrect)
  {
    this.sBorderColorCorrect = sBorderColorCorrect;
  }
  this.WidgetCovered = document.getElementById(sWidgetCoveredDomId);
  this.sWidgetCoveredDomId = sWidgetCoveredDomId;
  if (this.WidgetCovered == null)
  {
    ;
  }
  this.WidgetUncovered = document.getElementById(sWidgetUncoveredDomId);
  this.sWidgetUncoveredDomId = sWidgetUncoveredDomId;
  if (this.WidgetUncovered == null)
  {
    ;
  }
  this.addDomlet(new Domlet(
      this.sWidgetCoveredDomId,      
      this.sWidgetCoveredDomId,      
      this,                   
      new Array('click')) 
  )
  this.addDomlet(new Domlet(
      this.sWidgetUncoveredDomId,      
      this.sWidgetUncoveredDomId,      
      this,                   
      new Array('click')) 
  )
  this.sBorderColorUnassigned = this.WidgetUncovered.style.borderTopColor;
  if (! this.sBorderColorUnassigned )
  {
    this.sBorderColorUnassigned = 'transparent';
  }
}
Memory.prototype.registerMemoryManager = function(oMemoryManager)
{
  ;
  this.oMemoryManager = oMemoryManager;
}
Memory.prototype.getId = function()
{
  ;
  return this.sId;
}
Memory.prototype.setModelItem = function(modelItem)
{
  ;
  this.modelItem = modelItem;
}
Memory.prototype.getModelItem = function()
{
  ;
  return this.modelItem;
}
Memory.prototype.setBroker = function(broker)
{
  ;
  this.broker = broker;
}
Memory.prototype.changed = function(model)
{
  ;
  if (model.isEvaluated())
  {
    if (model.isSolved() == true)
    {
      this.WidgetUncovered.style.borderColor = this.sBorderColorCorrect;
      if (this.broker) { this.broker.showCorrect(); }
    }
    else if (model.isSolved() == false)
    {
      if (this.broker) { this.broker.showWrong(); }
    }
    else
    {
    }
  }
  else
  {
    var nCount = model.countActiveEvaluations();
    if (nCount == 0)
    {
      switch (model.getEvaluation().getOrigin())
      {
        case 'system_solution':
          break;
        default:
          if(this.modelItem.isQuestion())
          {
            var question = this.modelItem;
            var answer = this.modelItem.getComplementOffItem();
          }
          else
          {
            var question = this.modelItem.getComplementOffItem();
            var answer = this.modelItem;
          }
          if(question.workItem.getEvaluation(question, answer) && question.workItem.getEvaluation(question, answer).isActive())
          {
            this.WidgetUncovered.style.borderColor = this.sBorderColorUnassigned;
            this.domlets[this.sWidgetCoveredDomId].setVisible(false);
          }
          else
          {
            this.domlets[this.sWidgetCoveredDomId].setVisible(true);
            this.WidgetUncovered.style.borderColor = this.sBorderColorUnassigned;
            this.bClickable = true;
            if (this.broker) { this.broker.showUnassigned(); }
          }
       }
    }
    else if (nCount == 1)
    {
      switch (model.getEvaluation().getOrigin())
      {
        case 'user':
          this.domlets[this.sWidgetCoveredDomId].setVisible(false);
          this.WidgetUncovered.style.borderColor = this.sBorderColorCorrect;
          if (this.broker) { this.broker.showAssigned(); }
          break;
        case 'system_solution':
          this.domlets[this.sWidgetCoveredDomId].setVisible(false);
          this.WidgetUncovered.style.borderColor = this.sBorderColorCorrect;
          if (this.broker) { this.broker.showTipAssigned(); }
          break;
        case 'system_set':
          this.domlets[this.sWidgetCoveredDomId].setVisible(false);
          this.WidgetUncovered.style.borderColor = this.sBorderColorCorrect;
          if (this.broker) { this.broker.showTipAssigned(); }
          break;
        case 'system_approve':
          this.domlets[this.sWidgetCoveredDomId].setVisible(false);
          this.WidgetUncovered.style.borderColor = this.sBorderColorCorrect;
          if (this.broker) { this.broker.showTipApproveCorrect(); }
          break;
        case 'system_brand':
          break;
      }
    }
    else
    {
      ;
    }
  }
}
Memory.prototype.eventFromChild = function(childName, eventType, event)
{
  ;
  var domlet = this.domlets[childName];
  switch(eventType)
  {
    case "click":
      ;
      this.clickHandler(domlet, event);
      break;
  }
}
Memory.prototype.clickHandler = function(domlet, event)
{
  ;
  if(this.bClickable && this.oMemoryManager.clicks < 4 )
  {
    this.bClickable = false;
    if(this.oMemoryManager.clicks == 2)
    {
      this.oMemoryManager.clicked(this.modelItem);
      if(this.modelItem.isQuestion())
      {
        var question = this.modelItem;
        var answer = this.modelItem.getComplementOffItem();
      }
      else
      {
        var question = this.modelItem.getComplementOffItem();
        var answer = this.modelItem;
      }
      evaluation = question.workItem.getOrCreateEvaluation(question, answer);
      evaluation.setActive(true,'user');
    }
    else
    {
      if(this.modelItem.getSolutionComplement().isQuestion())
      {
        var question = this.modelItem.getSolutionComplement();
        var answer = this.modelItem.getSolutionComplement().getComplementOffItem();
      }
      else
      {
        var question = this.modelItem.getSolutionComplement().getComplementOffItem();
        var answer = this.modelItem.getSolutionComplement();
      }
      if(this.modelItem.workItem.getEvaluation(question, answer) && this.modelItem.workItem.getEvaluation(question, answer).isActive())
      {
        if(this.modelItem.isQuestion())
        {
          var question = this.modelItem;
          var answer = this.modelItem.getSolutionComplement();
        }
        else
        {
          var question = this.modelItem.getSolutionComplement();
          var answer = this.modelItem;
        }
        evaluation = question.workItem.getEvaluation(question, answer);
        evaluation.setActive(true,'user');
        this.oMemoryManager.clicked(this.modelItem);
      }
      else
      {
        if(this.modelItem.isQuestion())
        {
          var question = this.modelItem;
          var answer = this.modelItem.getComplementOffItem();
        }
        else
        {
          var question = this.modelItem.getComplementOffItem();
          var answer = this.modelItem;
        }
        evaluation = question.workItem.getOrCreateEvaluation(question, answer);
        evaluation.setActive(true,'user');
        this.oMemoryManager.clicked(this.modelItem);
      }
    }
  }
}
Memory.prototype.setBorderColorCorrect = function(sBorderColorCorrect)
{
  ;
  this.sBorderColorCorrect = sBorderColorCorrect;
}
