/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>BasicQeaTipStrategy</DEPENDS>
</DEPENDENCIES>
*/
MemTipMenMe = null;
function tipTimeoutCallback()
{
  MemTipMenMe.coverTip();
}
MemoryShortShowCorrectTipStrategy.prototype             = new BasicQeaTipStrategy();
MemoryShortShowCorrectTipStrategy.prototype.constructor = MemoryShortShowCorrectTipStrategy;
MemoryShortShowCorrectTipStrategy.superclass            = BasicQeaTipStrategy.prototype;
function MemoryShortShowCorrectTipStrategy(sId, tipTimeout)
{
  if (sId) { this.init(sId,tipTimeout); }
}
MemoryShortShowCorrectTipStrategy.prototype.init = function(sId, tipTimeout)
{
  ;
  this.bCycleTips = false;
  MemTipMenMe = this;
  this.tipTimeout = null;
  if(tipTimeout)
  {
    this.tipTimeout = tipTimeout;
  }
  else
  {
    this.tipTimeout = 500;
  }
  MemoryShortShowCorrectTipStrategy.superclass.init.call(this, sId);
  this.bCanCycleTips = false; 
}
MemoryShortShowCorrectTipStrategy.prototype.evaluationHasTip = function(evaluation, bStepByStep)
{
  ;
  var bHasTip = true;
  if (!(evaluation.isActive() && evaluation.hasOffItem()))
  {
    bHasTip = false;
  }
  var nEvaluations = 0;
  var nCorrectStatus = 0;
  if ( ! this.bSolutable)
  {
    for (var id in this.workItem.aEvaluations)
    {
      var e = this.workItem.aEvaluations[id];
      if (! e.hasOffItem())
      {
        nEvaluations++;
      }
      if (e.isActive())
      {
        if (e.isCorrect())
        {
          nCorrectStatus++;
        }
      }
    }
    if( ( nEvaluations - nCorrectStatus ) < 3 )
    {
      bHasTip = false;
    }
  }
  if ( bHasTip )
  {
    for ( var i in this.workItem.aEvaluations)
    {
      e = this.workItem.aEvaluations[i];
      if (e.isActive() && e.hasOffItem())
      {
        if ( e != evaluation )
        {
          bHasTip = false;
          break;
        }
      }
    }
  }
  return bHasTip;
}
MemoryShortShowCorrectTipStrategy.prototype.evaluationShowTip = function(evaluation, bStepByStep)
{
  ;
  var answer = evaluation.getAnswer();
  var question = evaluation.getQuestion();
  if(answer.isOffItem())
  {
    answer = question.getSolutionComplement();
  }
  else
  {
    question = answer.getSolutionComplement();
  }
  var correctEvaluation = answer.workItem.getEvaluation(question, answer);
  correctEvaluation.workItem.setUndoBreak('MemoryShortShowCorrectTipStrategy');
  correctEvaluation.setActive(true,'system_set');
  window.setTimeout('tipTimeoutCallback()',this.tipTimeout);
}
MemoryShortShowCorrectTipStrategy.prototype.coverTip = function()
{
  ;
  this.workItem.undo(false,'MemoryShortShowCorrectTipStrategy');
}
MemoryShortShowCorrectTipStrategy.prototype.setTipTimeout = function(tipTimeout)
{
  ;
  this.tipTimeout = tipTimeout;
}
