/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>ObjectMover</DEPENDS>
</DEPENDENCIES>
*/
Slider.prototype             = new ObjectMover();
Slider.prototype.constructor = Slider;
Slider.superclass            = ObjectMover.prototype;
function Slider(name, parent)
{
    if (name) this.init(name, parent);
    ;
} 
Slider.prototype.init = function(name, parent)
{
    ;
    Slider.superclass.init.call(this, name, parent);
    this.pixelsToScrollAtOnce = 3; 
    this.scrollingTimeout = 1; 
    sliderGlobalVariableNeedForTimout = this;
    this.scrollingStartListenerAction = new Array();
    this.scrollingCompleteListenerAction = new Array();
    this.scrollingActive = false;
}
Slider.prototype.setPixelsToScrollAtOnce = function(pixelsToScrollAtOnce)
{
    this.pixelsToScrollAtOnce = pixelsToScrollAtOnce;
}
Slider.prototype.setScrollingTimeout = function(scrollingTimeout)
{
    this.scrollingTimeout = scrollingTimeout;
}
Slider.prototype.setScrollingCompleteAction = function(action)
{
    this.scrollingCompleteAction = action;
}
Slider.prototype.addScrollingCompleteListenerAction = function(action)
{
    this.scrollingCompleteListenerAction[this.scrollingCompleteListenerAction.length] = action;
}
Slider.prototype.removeScrollingCompleteListenerAction = function(action)
{
    this.scrollingCompleteListenerAction = this.removeElementFromArray(action, this.scrollingCompleteListenerAction);
}
Slider.prototype.scrollingCompleteInternal = function()
{
    if (this.scrollingCompleteAction) this.scrollingCompleteAction.invoke();
    if (this.scrollingCompleteListenerAction.length != 0)
    {
        for (var i = 0; i < this.scrollingCompleteListenerAction.length; i++)
        {
            this.scrollingCompleteListenerAction[i].invoke();
        }
    }
}
Slider.prototype.setScrollingStartAction = function(action)
{
    this.scrollingStartAction = action;
}
Slider.prototype.addScrollingStartListenerAction = function(action)
{
    this.scrollingStartListenerAction[this.scrollingStartListenerAction.length] = action;
}
Slider.prototype.removeScrollingStartListenerAction = function(action)
{
    this.scrollingStartListenerAction = this.removeElementFromArray(action, this.scrollingStartListenerAction);
}
Slider.prototype.scrollingStartInternal = function()
{
    if (this.scrollingStartAction) this.scrollingStartAction.invoke();
    if (this.scrollingStartListenerAction.length != 0)
    {
        for (var i = 0; i < this.scrollingStartListenerAction.length; i++)
        {
            this.scrollingStartListenerAction[i].invoke();
        }
    }
}
Slider.prototype.slideRight = function(pixels)
{
    this.initSlide(pixels, "right");
}
Slider.prototype.slideLeft = function(pixels)
{
    this.initSlide(pixels, "left");
}
Slider.prototype.slideUp = function(pixels)
{
    this.initSlide(pixels, "up");
}
Slider.prototype.slideDown = function(pixels)
{
    this.initSlide(pixels, "down");
}
Slider.prototype.initSlide = function(pixels, direction)
{
    if(!this.scrollingActive)
    {
        ;
        this.scrollingDirection = direction;
        this.scrollingSteps = Math.floor(pixels / this.pixelsToScrollAtOnce);
        this.lastScrollStep = pixels % this.pixelsToScrollAtOnce;
        this.scrollCounter = this.scrollingSteps + 1;
        if (this.scrollCounter > 0)
        {
            this.scrollingActive = true;
            this.scrollingStartInternal();
            this.doTheSlide();
        }
    }
}
Slider.prototype.doTheSlide = function()
{
    if (--this.scrollCounter > 0)
    {
        this.moveElements(this.pixelsToScrollAtOnce, this.scrollingDirection);
    }
    else
    {
        if (this.lastScrollStep > 0)
        {
            this.moveElements(this.lastScrollStep, this.scrollingDirection);
        }
        else
        {
            this.scrollCounter--;
        }
    }
    if (this.scrollCounter > 0)
        setTimeout("sliderGlobalVariableNeedForTimout.doTheSlide()", this.scrollingTimeout);
    else
    {
        this.scrollingActive = false;
        this.scrollingCompleteInternal();
    }
}
