/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>QeaItem</DEPENDS>
    <DEPENDS>EmptyTextAnswerValue</DEPENDS>
    <DEPENDS>CasesensitiveTextAnswerValue</DEPENDS>
</DEPENDENCIES>
*/
Answer.prototype             = new QeaItem();
Answer.prototype.constructor = Answer;
Answer.superclass            = QeaItem.prototype;
function Answer(sId, nMax)
{
  if (sId) { this.init(sId, nMax); }
}
Answer.prototype.getSameItem = function(evaluation)
{
  //;
  return evaluation.getAnswer();
}
Answer.prototype.getComplementItem = function(evaluation)
{
  //;
  return evaluation.getQuestion();
}
Answer.prototype.getComplementOffItem = function()
{
  //;
  return this.workItem.offQuestion;
}
Answer.prototype.isOffItem = function()
{
  //;
  return this == this.workItem.offAnswer;
}
Answer.prototype.activateOffEvaluation = function()
{
  ;
  var e = this.workItem.getEvaluation(this.workItem.offQuestion, this);
  if (e)
  {
    e.setActive(true, 'system_off');
  }
}
Answer.prototype.getActiveQuestion = function()
{
  ;
  return this.getActiveComplement();
}
Answer.prototype.evaluate = function()
{
  ;
  if (!this.bEvaluated)
  {
    ;
    if ( this.workItem.bWithAlternatives )
    {
      var unusedCorrect = false;
      var correctEvaluationAvailable = false;
      this.bSolved = undefined;
      if (this.nMax == 1)
      {
        for (var id in this.workItem.aEvaluations)
        {
          var e = this.workItem.aEvaluations[id];
          if (this.getSameItem(e) == this)
          {
            if (!e.isActive() && e.isCorrect())
            {
              unusedCorrect = true;
            }
            if (e.isActive() && e.isCorrect())
            {
              unusedCorrect = false;
              this.bSolved = true;
              break;
            }
          }
        }
        if (!correctEvaluationAvailable)
        {
          this.bSolved = true;
        }
        if (unusedCorrect)
        {
          this.bSolved = false;
        }
      }
    }
    else
    {
      var countCorrect = 0;
      this.bSolved = undefined;
      for (var id in this.workItem.aEvaluations)
      {
        var e = this.workItem.aEvaluations[id];
        if (this.getSameItem(e) == this)
        {
          if (!e.isActive() && e.isCorrect())
          {
            this.bSolved = false;
            break;
          }
          if (e.isActive() && e.isCorrect())
          {
            countCorrect++;
          }
        }
      }
      if ( this.bSolved == undefined )
      {
        if (countCorrect == this.nCorrectEvaluations )
        {
          this.bSolved = true;
        }
        else
        {
          this.bSolved = false;
        }
      }
    }
  }
  if (this.bSolved != undefined)
  {
    this.bEvaluated = true;
    this.notify();
  }
}
Answer.prototype.isAnswer = function()
{
  return true;
}
Answer.prototype.getYPos = function()
{
  return null;
}
Answer.prototype.getXPos = function()
{
  return null;
}
TextAnswer.prototype             = new Answer();
TextAnswer.prototype.constructor = TextAnswer;
TextAnswer.superclass            = Answer.prototype;
function TextAnswer(sId, sText, nMax, bEmpty, answerValue)
{
  if (sId) { this.init(sId, sText, nMax, bEmpty, answerValue); }
}
TextAnswer.prototype.init = function(sId, sText, nMax, bEmpty, answerValue)
{
  ;
  TextAnswer.superclass.init.call(this, sId, nMax);
  this.value = answerValue;
  if(!answerValue)
  {
    if(bEmpty)
    {
      this.value = new EmptyTextAnswerValue(sId + '_value');
    }
    else
    {
      this.value = new CasesensitiveTextAnswerValue(sId + '_value', sText);
    }
  }
  this.text = this.value.getText();
}
TextAnswer.prototype.match = function(sText)
{
  ;
  return this.value.match(sText);
}
TextAnswer.prototype.getText = function()
{
  ;
  return this.value.getText();
}
TextAnswer.prototype.getGapSampleText = function()
{
  ;
  return this.value.getGapSampleText();
}
GridAnswer.prototype             = new Answer();
GridAnswer.prototype.constructor = GridAnswer;
GridAnswer.superclass            = Answer.prototype;
function GridAnswer(sId, nMax, nX, nY)
{
  if (sId) { this.init(sId, nMax, nX, nY); }
}
GridAnswer.prototype.init = function(sId, nMax, nX, nY)
{
  ;
  GridAnswer.superclass.init.call(this, sId, nMax);
  this.nCol = nX;
  this.nRow = nY;
}
GridAnswer.prototype.getCol = function()
{
  return this.nCol;
}
GridAnswer.prototype.getRow = function()
{
  return this.nRow;
}
TextGridAnswer.prototype             = new TextAnswer();
TextGridAnswer.prototype.constructor = TextGridAnswer;
TextGridAnswer.superclass            = TextAnswer.prototype;
function TextGridAnswer(sId, nMax, nX, nY, sText)
{
  if (sId) { this.init(sId, nMax, nX, nY, sText); }
}
TextGridAnswer.prototype.init = function(sId, nMax, nX, nY, sText)
{
  ;
  TextGridAnswer.superclass.init.call(this, sId, sText, nMax, false);
  this.nX = nX;
  this.nY = nY;
  this.sText = sText;
}
TextGridAnswer.prototype.getYPos = function()
{
  return this.nY;
}
TextGridAnswer.prototype.getXPos = function()
{
  return this.nX;
}
TextGridAnswer.prototype.match = function(sText, nX, nY)
{
  ;
  if(sText == null || sText == undefined)
    return false;
  return (this.sText.toLowerCase() == sText.toLowerCase() && this.nX == nX && this.nY == nY)
}
TextGridAnswer.prototype.changedEvaluation = function(evaluation)
{
  if (evaluation.isActive())
  {
    for (var id in this.workItem.aEvaluations)
    {
      var e = this.workItem.aEvaluations[id];
      if (e.isActive() && e != evaluation)
      {
        var a = e.getAnswer();
        if((a != this) && (a.nX == this.nX) && (a.nY == this.nY))
        {
          ;
          e.setActive(false, 'system_swapsingle');
        }
      }
    }
  }
  TextGridAnswer.superclass.changedEvaluation.call(this, evaluation);
}
HighlighterAnswer.prototype             = new Answer();
HighlighterAnswer.prototype.constructor = HighlighterAnswer;
HighlighterAnswer.superclass            = Answer.prototype;
function HighlighterAnswer(sId, nMax)
{
  if (sId) { this.init(sId, nMax); }
}
HighlighterAnswer.prototype.init = function(sId, nMax)
{
  ;
  this.nStartPos = -1;
  this.nLength = -1;
  HighlighterAnswer.superclass.init.call(this, sId, nMax);
}
HighlighterAnswer.prototype.match = function(nStartPos, nLength)
{
  ;
  return this.nStartPos == nStartPos && this.nLength == nLength && nStartPos != -1 && nLength != -1;
}
HighlighterAnswer.prototype.getStartPos = function()
{
  ;
  return this.nStartPos;
}
HighlighterAnswer.prototype.getLength = function()
{
  ;
  return this.nLength;
}
HighlighterAnswer.prototype.setStartPos = function(nStartPos)
{
  ;
  this.nStartPos = nStartPos;
}
HighlighterAnswer.prototype.setLength = function(nLength)
{
  ;
  this.nLength = nLength;
}
HighlighterAnswer.prototype.isAnswer = function()
{
  return 'Highlighter Answer';
}
