/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function Sequence(sId, bCorrect, bSolution)
{
  if (sId) { this.init(sId, bCorrect, bSolution); }
}
Sequence.prototype.init = function(sId, bCorrect, bSolution)
{
  ;
  this.sId = sId;
  this.bActive = false;
  this.bCorrect = bCorrect;
  this.bSolution = bCorrect; 
  if (bSolution == false) { this.bSolution = false; } 
  this.sOrigin = ''; 
  this.bEvaluated =  false;
  this.bUserActivated = false;
  this.bUserDeactivated = false;
  this.bSystemConstructive = false;
  this.bSystemCorrective = false;
  this.aSequenceList = new Array(); 
  this.nSequenceList = 0;
  this.workItem = null; 
  this.aSCListener = new Array(); 
  this.nSCListener = 0;
}
Sequence.prototype.getId = function()
{
  return this.sId;
}
Sequence.prototype.toString = function()
{
  var s = '' +
          ' id=' + this.sId +
          ' active=' + (this.bActive   ? '1'  : '0') +
          ' correct=' + (this.bCorrect  ? '1' : '0') +
          ' solution=' + (this.bSolution ? '1': '0') +
          ' ';
  for(var i=0; i<this.nSequenceList; i++)
  {
    s += '->' + this.aSequenceList[i].getId();
  }
  return s;
}
Sequence.prototype.start = function()
{
  ;
}
Sequence.prototype.setWorkItem = function(workItem)
{
  ;
  this.workItem = workItem;
}
Sequence.prototype.registerStatusChangeListener = function(scListener)
{
  ;
  if (this.aSCListener[scListener.getId()] != null)
  {
    ;
  }
  else
  {
    this.aSCListener[scListener.getId()] = scListener;
    this.nSCListener++;
    ;
    scListener.setModelItem(this);
  }
  return null;
}
Sequence.prototype.evaluate = function()
{
  ;
  this.bEvaluated = true;
  if (this.isCorrect())
  {  
    this.sOrigin = 'system_approve';
  }
  else
  {
    this.sOrigin = 'system_brand';
  }
  this.notify();
}
Sequence.prototype.setActive = function(bActive, sOrigin)
{
  ;
  this.sOrigin = (sOrigin == undefined) ? 'user' : sOrigin;
  this.bActive = bActive;
  this.notify();
}
Sequence.prototype.hasUserContribution = function()
{
  return this.bUserActivated || this.bUserDeactivated;
}
Sequence.prototype.hasSystemContribution = function()
{
  return this.bSystemConstructive || this.bSystemCorrective;
}
Sequence.prototype.hasSystemConstuction = function()
{
  return this.bSystemConstructive;
}
Sequence.prototype.hasSystemCorrection = function()
{
  return this.bSystemCorrective;
}
Sequence.prototype.setSystemConstuction = function(bSysCon)
{
  this.bSystemConstructive = bSysCon;
}
Sequence.prototype.setSystemCorrection = function(bSysCor)
{
  this.bSystemCorrective = bSysCor;
}
Sequence.prototype.isActive = function()
{
  return this.bActive;
}
Sequence.prototype.isCorrect = function()
{
  return this.bCorrect;
}
Sequence.prototype.isSolution = function()
{
  return this.bSolution;
}
Sequence.prototype.isEvaluated = function()
{
  return this.bEvaluated;
}
Sequence.prototype.getOrigin = function()
{
  return this.sOrigin;
}
Sequence.prototype.notify = function()
{
  ;
  if (this.workItem.getNotifyView())
  {
    for (var id in this.aSCListener)
    {
      this.aSCListener[id].changed(this);
    }
  }
}
Sequence.prototype.addLastSequenceItem = function(sequenceItem)
{
  ;
  if (this.getPositionOfSequenceItem(sequenceItem) > -1)
  {
    ;
  } 
  else
  {
    this.insertSequenceItemAtPosition(sequenceItem, this.nSequenceList);
  }
}
Sequence.prototype.addFirstSequenceItem = function(sequenceItem)
{
  ;
  if (this.getPositionOfSequenceItem(sequenceItem) > -1)
  {
    ;
  } 
  else
  {
    this.insertSequenceItemAtPosition(sequenceItem, 0);
  }
}
Sequence.prototype.removeSequenceItem = function(sequenceItem)
{
  ;
  var bFound = false;
  for(var i=0; i<this.nSequenceList; i++)
  {
    if(sequenceItem.getId() == this.aSequenceList[i].getId())
    {
      bFound = true;
    }
    if (bFound)
    {
      this.aSequenceList[i] = this.aSequenceList[i+1];
    }
  }
  if (bFound)
  {
    this.aSequenceList[this.nSequenceList] = undefined;
    this.nSequenceList--;
  }
  return bFound;
}
Sequence.prototype.insertSequenceItemAtPosition = function(sequenceItem, nPosition)
{
  ;
  if (this.getPositionOfSequenceItem(sequenceItem) > -1)
  {
    ;
  } 
  else
  {
    if (nPosition > this.nSequenceList)
    {
      nPosition = this.nSequenceList; 
    }
    if (nPosition < 0)
    {
      nPosition = 0; 
    }
    for (var i=this.nSequenceList; (i >= nPosition && i >= 0); i--)
    {
      this.aSequenceList[i+1] = this.aSequenceList[i];
    }
    this.aSequenceList[nPosition] = sequenceItem;
    this.nSequenceList++;
  }
}
Sequence.prototype.copySequenceList = function(sequence)
{
  ;
  this.nSequenceList = 0;
  this.aSequenceList = new Array();
  for(var i=0; i<sequence.nSequenceList; i++)
  {
    this.aSequenceList[i] = sequence.aSequenceList[i];
  }
  this.nSequenceList = sequence.nSequenceList;
}
Sequence.prototype.getNextSequenceItem = function(lastSequenceItem)
{
  ;
  var nextSequenceItem = null;
  for (var id=0; id< this.nSequenceList; id++)
  {
    if (lastSequenceItem == null)
    {
      nextSequenceItem = this.aSequenceList[id];
      break;
    }
    else
    {
      if (this.aSequenceList[id] == lastSequenceItem) { lastSequenceItem = null; }
    }
  }
  ;
  return nextSequenceItem;
}
Sequence.prototype.match = function(sequence)
{
  ;
  var bMatch = true;
  if (this.nSequenceList != sequence.nSequenceList)
  {
    bMatch = false;
    ;
  }
  if (bMatch)
  {
    for(var i=0; i<this.nSequenceList; i++)
    {
      if ( ! this.aSequenceList[i].compare(sequence.aSequenceList[i]))
      {
        bMatch = false;
        ;
        break;
      }
    }
  }
  return bMatch;
}
Sequence.prototype.countMatchingSequenceItems = function(sequence)
{
  ;
  var nMatching = 0;
  for(var i=0; i<this.nSequenceList; i++)
  {
    if (i < sequence.nSequenceList)
    {
      if ( this.aSequenceList[i].compare(sequence.aSequenceList[i]))
      {
        nMatching++;
      }
    }
  }
  return nMatching;
}
Sequence.prototype.countSequenceItems = function()
{
  ;
  return this.nSequenceList;
}
Sequence.prototype.getPositionOfSequenceItem = function(sequenceItem)
{
  ;
  var nPosition = -1;
  for(var i=0; i<this.nSequenceList; i++)
  {
    if (this.aSequenceList[i] == sequenceItem)
    {
      nPosition = i;
      break;
    }
  }
  return nPosition;
}
Sequence.prototype.getSequenceItemAtPosition = function(nPos)
{
  ;
  var oSequenceItem = null;  
  if (this.aSequenceList[nPos])
  {
    oSequenceItem = this.aSequenceList[nPos];
  }
  return oSequenceItem;
}
Sequence.prototype.reset = function()
{
  ;
  this.setActive(false, 'user');
  this.bUserActivated = false;
  this.bUserDeactivated = false;
  this.bSystemConstructive = false;
  this.bSystemCorrective = false;
  this.bUncovered = false;
  this.bEvaluated = false;
}
