/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
</DEPENDENCIES>
*/
function LocationService(id)
{
	this.id = id;
	this.listener = new Array();
	this.initialized = false;
	this.locations = new Array();
}
LocationService.prototype.start = function()
{
	if (serviceregistry)
	{
		;
		serviceregistry.registerService('locationservice', this);
		
		this.initialized = true;
		this.notifyListener();
	}
}
LocationService.prototype.registerLoadedListener = function(action)
{
	;
	return this.listener.push(action);
}
LocationService.prototype.notifyListener = function()
{
	;
	for (var i = 0; i < this.listener.length; i++)
	{
		this.listener[i].invoke();
	}
}
LocationService.prototype.isInitialized = function()
{
	return this.initialized;
}
LocationService.prototype.hasLastVistedLocation = function()
{
	return (this.lastvisted != null);
}
LocationService.prototype.getLastVistedLocation = function()
{
	return this.lastvisted;
}
LocationService.prototype.getStartLocation = function()
{
	return 'start.html';
}
LocationService.prototype.setLastVistedLocation = function(folder, structureEntry)
{
	if (folder && structureEntry)
	{
		this.locations[folder.getContentId()] = new LastVisited(folder, structureEntry);
		this.lastvisted = structureEntry.getURL();
	}
}
LocationService.prototype.setInitialLastVisitedLocation = function(url)
{
	if ('' != url)
		this.lastvisted = url;
}
LocationService.prototype.getLastVistedLocationInFolder = function(folderId)
{
	var lastvisited = this.locations[folderId];
	if (lastvisited)
	{
		return lastvisited.getURL();
	}
	else
	{
		return null;
	}
}
LocationService.prototype.hasLastVistedLocationInFolder = function(folderId)
{
	return (this.getLastVistedLocationInFolder(folderId) != null);
}
LocationService.prototype.getAllLastVisitedLocations = function()
{
	var all = new Array();
	for (var folderId in this.locations)
	{
		all.push(this.locations[folderId]);
	}
	return all;
}
function LastVisited(folder, entry)
{
	this.folder = folder;
	this.entry = entry;
}
LastVisited.prototype.getURL = function()
{
	return this.entry.getURL();
}
LastVisited.prototype.getSerialized = function()
{
	var serialized = this.folder.getIndex() + "_" + this.entry.getIndex();
	return serialized;
}
