/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>ScoreStatistics</DEPENDS>
    <DEPENDS>EvaluationEntry</DEPENDS>
</DEPENDENCIES>
*/
function ScoreEvaluatorStandard() {
  	;
}
ScoreEvaluatorStandard.prototype.evaluateSingleScoreTrace = function(evaluationEntry)
{
	if (!evaluationEntry.hasData())
    		return new ScoreStatistics(0,0,0,0,1);
       	else
       	{
		var score = evaluationEntry.getData();	
		
		
		
		
		
		var base = Math.max(score.getNumWrong(), score.getNumCorrect());
		
		
		
		var wrongUser = this.getWrongByUser(score.getNumWrongStatus());
		
		
		
		
		
		
		
		
		var correctOffset = this.getCorrectOffset(score.getNumCorrect(), score.getNumWrong(), wrongUser);
		
		
		
		
		
	    
		
		
		
		
		var correctHelp = this.getCorrectWithHelp(score.getNumCorrectSystem(), base, wrongUser);
		
		
		
		
		var correctUser = this.getCorrectByUser(correctOffset, correctHelp, score.getNumCorrectStatus());
		
		
		
		
		var untouched = this.getUntouched(base, correctUser, wrongUser, correctHelp);
		wrongUser = wrongUser + untouched;
		var fractionCorrectByUser = correctUser / base;
		var fractionCorrectWithHelp = correctHelp / base;
		var fractionWrong = wrongUser / base;
		var fractUntouched = 0;
		var fractUntouched = this.harmonize(
			fractUntouched, fractionWrong,
			fractionCorrectWithHelp, fractionCorrectByUser);
		var fractTracked = 1.0
			- fractUntouched
			- fractionWrong
			- fractionCorrectWithHelp
			- fractionCorrectByUser;
		var fractTracked = Math.max(0.0, fractTracked);
		var stat = new ScoreStatistics(
					fractionCorrectByUser, fractionCorrectWithHelp, fractionWrong,
					fractTracked, fractUntouched);
		return stat;
    	}
}
ScoreEvaluatorStandard.prototype.evaluateSingleScoreTrack = function(evaluationEntry)
{
	if (!evaluationEntry.hasData())
       		return new ScoreStatistics(0, 0, 0, 0, 1);
       	else
        	return new ScoreStatistics(0, 0, 0, 1, 0);
}
ScoreEvaluatorStandard.prototype.evaluateAverage = function(numuntouched, statisticEntries)
{
	var numStats = statisticEntries.length;
	var num = numStats + numuntouched;
	var numTraced = 0;
	var correctByUser = 0;
	var correctWithHelp = 0;
	var wrong = 0;
	var tracked = 0;
	var untouched = 0;
	for (var i = 0; i <  statisticEntries.length; i++) {
		var stat = statisticEntries[i];
		correctByUser += stat.getFractionCorrect();
		correctWithHelp += stat.getFractionCorrectWithHelp();
		wrong += stat.getFractionWrong();
		tracked += stat.getFractionDone();
		untouched += stat.getFractionUndone();
   }
	var fractCorrectByUser = 0;
	var fractCorrectWithHelp = 0;
	var fractWrong = 0;
	var fractTracked = 0;
	var fractUntouched = 1;
	if (num != 0)
	{
		fractCorrectByUser = correctByUser / num;
		fractCorrectWithHelp = correctWithHelp / num;
		fractWrong = wrong / num;
		fractTracked = (tracked) / num;
		fractUntouched = (untouched + numuntouched) / num;
	}
	stat = new ScoreStatistics(
			fractCorrectByUser,
			fractCorrectWithHelp,
			fractWrong,
			fractTracked,
			fractUntouched);
	return stat;
}
ScoreEvaluatorStandard.prototype.getCorrectOffset = function(numCorrect, numWrong, wrongUser)
{
	var offset = 0;
	offset = numWrong - numCorrect - wrongUser;
	if (offset < 0)
		offset = 0;
	return offset;
}
ScoreEvaluatorStandard.prototype.getUntouched = function(base, correctUser, wrongUser, correctHelp)
{
	var untouched = (base - (correctUser + wrongUser + correctHelp));
	if (untouched < 0)
		untouched = 0;
	return untouched;
}
ScoreEvaluatorStandard.prototype.getWrongByUser = function(numWrongStatus)
{
	if(numWrongStatus < 0)
		numWrongStatus = 0;
	return numWrongStatus;
}
ScoreEvaluatorStandard.prototype.getCorrectWithHelp = function(numCorrectSystem, base, wrongUser)
{
	if (numCorrectSystem < 0)
		return 0;
	var correctWithHelp = numCorrectSystem;
	var possibleCorrect = base - wrongUser;
    if (correctWithHelp > possibleCorrect)
    	correctWithHelp = possibleCorrect;
	return correctWithHelp;
}
ScoreEvaluatorStandard.prototype.getCorrectByUser = function(correctOffset, correctHelp, numCorrectStatus)
{
	var correct = 0;
	if (numCorrectStatus < 0)
		numCorrectStatus = 0;
	
    correct = numCorrectStatus + correctOffset - correctHelp;
    if (correct < 0)
   		correct = 0;
    return correct;
}
ScoreEvaluatorStandard.prototype.harmonize = function(fractUntouched, fractionWrong, fractionCorrectWithHelp, fractionCorrectByUser)
{
	sum = fractionWrong
			+ fractionCorrectWithHelp + fractionCorrectByUser;
	if (fractUntouched + sum <= 1)
		return fractUntouched;
}
